local _G = _G
local MAIN_HAND_INV_TYPE = 21;
local OFF_HAND_INV_TYPE = 22;
local RANGED_INV_TYPE = 15;
local TAB_ITEMS = 1;
local TAB_SETS = 2;
local TABS_MAX_WIDTH = 185;

local WARDROBE_MODEL_SETUP = {
	["HEADSLOT"] 		= { useTransmogSkin = false, slots = { CHESTSLOT = true,  HANDSSLOT = false, LEGSSLOT = false, FEETSLOT = false, HEADSLOT = false} },
	["SHOULDERSLOT"]	= { useTransmogSkin = true,  slots = { CHESTSLOT = false, HANDSSLOT = false, LEGSSLOT = false, FEETSLOT = false, HEADSLOT = true } },
	["BACKSLOT"]		= { useTransmogSkin = true,  slots = { CHESTSLOT = false, HANDSSLOT = false, LEGSSLOT = false, FEETSLOT = false, HEADSLOT = true } },
	["CHESTSLOT"]		= { useTransmogSkin = true,  slots = { CHESTSLOT = false, HANDSSLOT = false, LEGSSLOT = false, FEETSLOT = false, HEADSLOT = true } },
	["TABARDSLOT"]		= { useTransmogSkin = true,  slots = { CHESTSLOT = false, HANDSSLOT = false, LEGSSLOT = false, FEETSLOT = false, HEADSLOT = true } },
	["SHIRTSLOT"]		= { useTransmogSkin = true,  slots = { CHESTSLOT = false, HANDSSLOT = false, LEGSSLOT = false, FEETSLOT = false, HEADSLOT = true } },
	["WRISTSLOT"]		= { useTransmogSkin = true,  slots = { CHESTSLOT = false, HANDSSLOT = false, LEGSSLOT = false, FEETSLOT = false, HEADSLOT = true } },
	["HANDSSLOT"]		= { useTransmogSkin = false, slots = { CHESTSLOT = true,  HANDSSLOT = false, LEGSSLOT = true,  FEETSLOT = true,  HEADSLOT = true } },
	["WAISTSLOT"]		= { useTransmogSkin = true,  slots = { CHESTSLOT = false, HANDSSLOT = false, LEGSSLOT = false, FEETSLOT = false, HEADSLOT = true } },
	["LEGSSLOT"]		= { useTransmogSkin = true,  slots = { CHESTSLOT = false, HANDSSLOT = false, LEGSSLOT = false, FEETSLOT = false, HEADSLOT = true } },
	["FEETSLOT"]		= { useTransmogSkin = false, slots = { CHESTSLOT = true,  HANDSSLOT = true,  LEGSSLOT = true,  FEETSLOT = false, HEADSLOT = true } },	
}

local WARDROBE_MODEL_SETUP_GEAR = {
	["CHESTSLOT"] = 78420,
	["LEGSSLOT"] = 78425,
	["FEETSLOT"] = 78427,
	["HANDSSLOT"] = 78426,
	["HEADSLOT"] = 78416,
}

function AnvilWardrobeCollectionFrame_ClickTab(tab)
	AnvilWardrobeCollectionFrame_SetTab(tab:GetID());
	PanelTemplates_ResizeTabsToFit(AnvilWardrobeCollectionFrame, TABS_MAX_WIDTH);
	PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_ON);
end

function AnvilWardrobeCollectionFrame_SetTab(tabID)
	PanelTemplates_SetTab(AnvilWardrobeCollectionFrame, tabID);
	AnvilWardrobeCollectionFrame.selectedCollectionTab = tabID;
	if ( tabID == TAB_ITEMS ) then
		AnvilWardrobeCollectionDressUpFrame.DressUpModel:Dress()
		for i=1, 13 do
			if AnvilWardrobeCollectionFrame.ItemsCollectionFrame.anvilItems[i].displayedItem then
				AnvilWardrobeCollectionDressUpFrame.DressUpModel:TryOn(AnvilWardrobeCollectionFrame.ItemsCollectionFrame.anvilItems[i].displayedItem)
			else
				local slots = { "HEAD", "SHOULDER", "BACK", "CHEST", "SHIRT", "TABARD", "WRIST", "HANDS", "WAIST", "LEGS", "FEET", "MAINHAND", "SECONDARYHAND" };
				local isTransmog = C_Transmog.GetSlotInfo(GetInventorySlotInfo(slots[i].."SLOT"), LE_TRANSMOG_TYPE_APPEARANCE)
				if not isTransmog and AnvilWardrobeCollectionFrame.ItemsCollectionFrame.anvilItems[i].itemID then
					AnvilWardrobeCollectionDressUpFrame.DressUpModel:TryOn(AnvilWardrobeCollectionFrame.ItemsCollectionFrame.anvilItems[i].itemID)
				end
			end
			if AnvilWardrobeCollectionFrame.ItemsCollectionFrame.anvilItems[i].displayedEnchant then
				AnvilWardrobeCollectionDressUpFrame.DressUpModel:TryOn(AnvilWardrobeCollectionFrame.ItemsCollectionFrame.anvilItems[i].displayedEnchant, i, AnvilWardrobeCollectionFrame.ItemsCollectionFrame.anvilItems[i].visualSourceID)
			end
		end
		AnvilWardrobeCollectionDressUpFrame.DetailsFrame.Name:Hide()
		AnvilWardrobeCollectionDressUpFrame.DetailsFrame.ModelFadeTexture:Hide()
		AnvilWardrobeCollectionDressUpFrame.DetailsFrame.IconRowBackground:Hide()
		AnvilWardrobeCollectionDressUpFrame.DetailsFrame.Label:Hide()
		AnvilWardrobeSetsCollectionVariantSetsButton:Hide()
		AnvilWardrobeCollectionFrame.activeFrame = AnvilWardrobeCollectionFrame.ItemsCollectionFrame;
		AnvilWardrobeCollectionFrame.ItemsCollectionFrame:Show();
		AnvilWardrobeCollectionFrame.SetsCollectionFrame:Hide();
		AnvilWardrobeCollectionFrame.searchBox:ClearAllPoints();
		AnvilWardrobeCollectionFrame.searchBox:SetPoint("TOPRIGHT", -107, -35);
		AnvilWardrobeCollectionFrame.searchBox:SetWidth(115);
		AnvilWardrobeCollectionFrame.searchBox:SetEnabled(AnvilWardrobeCollectionFrame.ItemsCollectionFrame.transmogType == LE_TRANSMOG_TYPE_APPEARANCE);
		AnvilWardrobeCollectionFrame.FilterButton:SetEnabled(AnvilWardrobeCollectionFrame.ItemsCollectionFrame.transmogType == LE_TRANSMOG_TYPE_APPEARANCE);
		AnvilWardrobeCollectionDressUpControlButtons:Show()
		AnvilWardrobeCollectionDressUpFrame.DressUpModel:SetPoint("TOPLEFT", 5, -36)
		AnvilWardrobeCollectionDressUpFrame.DressUpModel:SetPoint("BOTTOMRIGHT", 0, 36)
		AnvilWardrobeCollectionDressUpFrame.DressUpModel.controlFrame:Show()
		AnvilWardrobeCollectionDressUpFrame.DressUpModel:SetPosition(0,0,0)
		AnvilWardrobeCollectionDressUpFrame.DressUpModel:RefreshCamera()
		AnvilWardrobeCollectionDressUpFrame.DressUpModel:SetFacing(.61)
	elseif ( tabID == TAB_SETS ) then
		for i=1, 13 do
			AnvilWardrobeCollectionFrame.ItemsCollectionFrame.anvilItems[i]:Hide()
		end
		AnvilWardrobeCollectionDressUpFrame.DetailsFrame.Name:Show()
		AnvilWardrobeCollectionDressUpFrame.DetailsFrame.ModelFadeTexture:Show()
		AnvilWardrobeCollectionDressUpFrame.DetailsFrame.IconRowBackground:Show()
		AnvilWardrobeCollectionDressUpFrame.DetailsFrame.Label:Show()
		AnvilWardrobeSetsCollectionVariantSetsButton:Show()
		AnvilWardrobeCollectionFrame.activeFrame = AnvilWardrobeCollectionFrame.SetsCollectionFrame;
		AnvilWardrobeCollectionFrame.ItemsCollectionFrame:Hide();
		AnvilWardrobeCollectionFrame.searchBox:ClearAllPoints();
		AnvilWardrobeCollectionFrame.searchBox:SetPoint("TOPLEFT", 19, -69);
		AnvilWardrobeCollectionFrame.searchBox:SetWidth(145);
		AnvilWardrobeCollectionFrame.FilterButton:SetEnabled(true);
		AnvilWardrobeCollectionFrame.searchBox:SetEnabled(true);
		AnvilWardrobeCollectionFrame.SetsCollectionFrame:Show()
		AnvilWardrobeCollectionDressUpControlButtons:Hide()
		AnvilWardrobeCollectionDressUpFrame.DressUpModel:SetPoint("TOPLEFT", 5, -140)
		AnvilWardrobeCollectionDressUpFrame.DressUpModel:SetPoint("BOTTOMRIGHT", 0, 4)
		AnvilWardrobeCollectionDressUpFrame.DressUpModel.controlFrame:Hide()
		AnvilWardrobeCollectionDressUpFrame.DressUpModel:SetPosition(0,0,0)
		AnvilWardrobeCollectionDressUpFrame.DressUpModel:RefreshCamera()
	end
	collectgarbage("collect")
end

function AnvilWardrobeCollectionFrame_OnLoad(self)
	AnvilWardrobeCollectionFrame.activeFrame = AnvilWardrobeCollectionFrame.ItemsCollectionFrame
	PanelTemplates_SetNumTabs(self, 2);
	PanelTemplates_SetTab(self, TAB_ITEMS);
	PanelTemplates_ResizeTabsToFit(self, TABS_MAX_WIDTH);
	self.selectedCollectionTab = TAB_ITEMS;
	SetPortraitToTexture(AnvilCollectionsJournalPortrait, "Interface\\Icons\\inv_misc_enggizmos_19");
	AnvilWardrobeCollectionDressUpFrame.DressUpModel:SetScript("OnEnter", nil)
	AnvilWardrobeCollectionDressUpFrame.DressUpModel:SetScript("OnLeave", nil)
end

AnvilWardrobeItemsCollectionMixin = {};

function AnvilWardrobeItemsCollectionMixin:CreateSlotButtons()
	local slots = { "HEAD", "SHOULDER", "BACK", "CHEST", "SHIRT", "TABARD", "WRIST", "HANDS", "WAIST", "LEGS", "FEET", 28, "MAINHAND", 24, "SECONDARYHAND" };
	local parentFrame = self.SlotsFrame;
	local lastButton;	
	local yOffset = 2;
	local mainHandButton, secondaryHandButton;
	for i = 1, #slots do
		local value = tonumber(slots[i]);
		if not self.anvilSlots[i] then
			self.anvilSlots[i] = {}
		end
		if ( value ) then
			yOffset = value;
		else
			local button = CreateFrame("BUTTON", nil, parentFrame, "AnvilWardrobeSlotButtonTemplate");
			button.NormalTexture:SetAtlas("transmog-nav-slot-"..slots[i], true);
			if ( lastButton ) then
				button:SetPoint("TOPLEFT", lastButton, "BOTTOMLEFT", 0, -yOffset);
			else
				button:SetPoint("TOPLEFT");
			end
			button.slot = slots[i].."SLOT";
			yOffset = 2;
			lastButton = button;
			if ( slots[i] == "MAINHAND" ) then
				mainHandButton = button;
			elseif ( slots[i] == "SECONDARYHAND" ) then
				secondaryHandButton = button;
			end
			self.anvilSlots[i].slotName = button.slot
		end
	end
	local mainHandEnchantButton = CreateFrame("BUTTON", nil, parentFrame, "AnvilWardrobeEnchantButtonTemplate");
	mainHandEnchantButton:SetPoint("TOP", mainHandButton, "BOTTOM", 0, 4);
	mainHandEnchantButton.slot = mainHandButton.slot;
	local secondaryHandEnchantButton = CreateFrame("BUTTON", nil, parentFrame, "AnvilWardrobeEnchantButtonTemplate");
	secondaryHandEnchantButton:SetPoint("TOP", secondaryHandButton, "BOTTOM", 0, 4);
	secondaryHandEnchantButton.slot = secondaryHandButton.slot;
	parentFrame.EnchantButtons = { mainHandEnchantButton, secondaryHandEnchantButton };
end

function AnvilWardrobeItemsCollectionMixin:OnEvent(event, ...)
	if ( event == "PLAYER_EQUIPMENT_CHANGED" ) then
		AnvilWardrobeCollectionDressUpFrame.DressUpModel:Dress()
		self:UpdateItems();
		AnvilDrawDressUpButtons()
	elseif ( event == "TRANSMOG_COLLECTION_UPDATED") then
		self:CheckLatestAppearance(true);
		self:ValidateChosenVisualSources();
		if ( self:IsVisible() ) then
			self:RefreshVisualsList();
			self:UpdateItems();
		end
		AnvilWardrobeCollectionFrame_UpdateTabButtons();
	end
end

function AnvilWardrobeCollectionFrame_OnEvent(self, event, ...)
	if ( event == "TRANSMOG_COLLECTION_ITEM_UPDATE" ) then
		if ( self.tooltipContentFrame ) then
			self.tooltipContentFrame:RefreshAppearanceTooltip();
		end
		if ( self.ItemsCollectionFrame:IsShown() ) then
			self.ItemsCollectionFrame:ValidateChosenVisualSources();
		end
	elseif ( event == "UNIT_MODEL_CHANGED" ) then
		local hasAlternateForm, inAlternateForm = HasAlternateForm();
		if ( (self.inAlternateForm ~= inAlternateForm or self.updateOnModelChanged) ) then
			if ( self.activeFrame:OnUnitModelChangedEvent() ) then
				self.inAlternateForm = inAlternateForm;
				self.updateOnModelChanged = nil;
			end
		end
	elseif ( event == "PLAYER_LEVEL_UP" or event == "SKILL_LINES_CHANGED" or event == "UPDATE_FACTION" or event == "SPELLS_CHANGED" ) then
		AnvilWardrobeCollectionFrame_UpdateUsableAppearances();
	elseif ( event == "TRANSMOG_SEARCH_UPDATED" ) then
		local searchType, arg1 = ...;
		if ( searchType == self.activeFrame.searchType ) then
			self.activeFrame:OnSearchUpdate(arg1);
		end
	elseif ( event == "SEARCH_DB_LOADED" ) then
		AnvilWardrobeCollectionFrame_RestartSearchTracking();
	elseif ( event == "UI_SCALE_CHANGED" or event == "DISPLAY_SIZE_CHANGED" or event == "TRANSMOG_COLLECTION_CAMERA_UPDATE" ) then
		AnvilWardrobeCollectionFrame_RefreshCameras();
	end
end

function AnvilWardrobeCollectionFrame_UpdateUsableAppearances()
	if ( not AnvilWardrobeCollectionFrame.updateUsableAppearances ) then
		AnvilWardrobeCollectionFrame.updateUsableAppearances = true;
		C_Timer.After(0, function() AnvilWardrobeCollectionFrame.updateUsableAppearances = nil; C_TransmogCollection.UpdateUsableAppearances(); end);
	end
end

function AnvilWardrobeCollectionFrame_RefreshCameras()
	for i, frame in ipairs(AnvilWardrobeCollectionFrame.ContentFrames) do
		frame:RefreshCameras();
	end
end

function AnvilWardrobeItemsCollectionMixin:CheckLatestAppearance(changeTab)
	local latestAppearanceID, latestAppearanceCategoryID = C_TransmogCollection.GetLatestAppearance();
	if ( self.latestAppearanceID ~= latestAppearanceID ) then
		self.latestAppearanceID = latestAppearanceID;
		self.jumpToLatestAppearanceID = latestAppearanceID;
		self.jumpToLatestCategoryID = latestAppearanceCategoryID;

		if ( changeTab and not AnvilCollectionsJournal:IsShown() ) then
			AnvilCollections_SetTab(AnvilCollectionsJournal, 5);
		end
	end
end

function AnvilWardrobeItemsCollectionMixin:OnLoad()
	self.anvilSlots = {}
	self.anvilItems = {}
	self:CreateSlotButtons();
	self.HiddenModel:SetKeepModelOnHide(true);
	self.chosenVisualSources = { };
	self.NUM_ROWS = 4;
	self.NUM_COLS = 6;
	self.PAGE_SIZE = self.NUM_ROWS * self.NUM_COLS;
	UIDropDownMenu_Initialize(self.RightClickDropDown, nil, "MENU");
	self.RightClickDropDown.initialize = AnvilWardrobeCollectionFrameRightClickDropDown_Init;
	self:RegisterEvent("TRANSMOG_COLLECTION_UPDATED");
	self:CheckLatestAppearance();
end

function AnvilWardrobeItemsCollectionMixin:ShouldShowSetsHelpTip()
	if (GetCVarBitfield("closedInfoFrames", LE_FRAME_TUTORIAL_TRANSMOG_SETS_TAB)) then
		return false;
	end
	if (not GetCVarBitfield("closedInfoFrames", LE_FRAME_TUTORIAL_TRANSMOG_MODEL_CLICK)) then
		return false;
	end
	self:GetParent().SetsTabHelpBox.BigText:SetText(TRANSMOG_SETS_TAB_TUTORIAL);
	self:GetParent().SetsTabHelpBox:SetHeight(self:GetParent().SetsTabHelpBox.BigText:GetHeight() + HELPTIP_HEIGHT_PADDING);
	return true;
end

function AnvilWardrobeItemsCollectionMixin:OnShow()
	self:RegisterEvent("TRANSMOGRIFY_UPDATE");
	self:RegisterEvent("PLAYER_EQUIPMENT_CHANGED");
	self:RegisterEvent("TRANSMOGRIFY_SUCCESS");
	local needsUpdate = false;
	if ( self.jumpToLatestCategoryID and self.jumpToLatestCategoryID ~= self.activeCategory ) then
		local slot = AnvilWardrobeCollectionFrame_GetSlotFromCategoryID(self.jumpToLatestCategoryID);
		self:SetActiveSlot(slot, LE_TRANSMOG_TYPE_APPEARANCE, self.jumpToLatestCategoryID);
		self.jumpToLatestCategoryID = nil;
	elseif ( self.activeSlot ) then
		self:ChangeModelsSlot(nil, self.activeSlot);
		needsUpdate = true;
	else
		self:SetActiveSlot("HEADSLOT", LE_TRANSMOG_TYPE_APPEARANCE);
	end

	if ( needsUpdate ) then
		self:RefreshVisualsList();
		self:UpdateItems();
		self:UpdateWeaponDropDown();
	end
	SetCVarBitfield("closedInfoFrames", LE_FRAME_TUTORIAL_TRANSMOG_JOURNAL_TAB, true);
	self:GetParent().SetsTabHelpBox:SetShown(self:ShouldShowSetsHelpTip());
	AnvilDrawDressUpButtons()
end

function AnvilDrawDressUpButtons(reDress, unDress)
	local self = AnvilWardrobeCollectionFrame.ItemsCollectionFrame
	AnvilWardrobeCollectionDressUpFrame.DetailsFrame.itemFramesPool:ReleaseAll();
	local slots = { "Head", "Shoulder", "Back", "Chest", "Shirt", "Tabard", "Wrist", "Hands", "Waist", "Legs", "Feet", "MainHand", "SecondaryHand" };
	for i = 1, 13 do
		if not self.anvilItems[i] then
			self.anvilItems[i] = CreateFrame("Frame", nil, AnvilWardrobeCollectionDressUpFrame.DetailsFrame, "AnvilWardrobeDetailsItemFrameTemplate");
			self.anvilItems[i]:SetScale(1.5)
			self.anvilItems[i]:SetScript("OnEnter", AnvilItemTooltips)
			self.anvilItems[i].IconBorder:Hide()
			if i<7 then
				self.anvilItems[i]:SetPoint("TOPLEFT", 8, -56-(i*30));
			elseif i<12 then
				self.anvilItems[i]:SetPoint("TOPRIGHT", -8, -48-((i-6)*38));
			else
				self.anvilItems[i]:SetPoint("CENTER", AnvilWardrobeCollectionDressUpFrame, "BOTTOM", ((2*i-25)*20), 24);
			end
			reDress=true
			if i == 12 then
				self.anvilItems[i].slotName = "Main Hand"
			elseif i == 13 then
				self.anvilItems[i].slotName = "Off Hand"
			else
				self.anvilItems[i].slotName = slots[i]
			end
			self.anvilItems[i].slotID, self.anvilItems[i].slotTexture = GetInventorySlotInfo(slots[i].."Slot")
		end
		if reDress or unDress then
			self.anvilItems[i].displayedItem = nil
			self.anvilItems[i].displayedEnchant = nil
			self.anvilItems[i].visualSourceID = nil
		end
		if reDress and GetInventoryItemID("player", self.anvilItems[i].slotID) then
			self.anvilItems[i].itemID = "item:"..GetInventoryItemID("player", self.anvilItems[i].slotID)
		end
		if unDress or (not GetInventoryItemID("player", self.anvilItems[i].slotID)) then
			self.anvilItems[i].itemID = nil
		end
		local texture
		if self.anvilItems[i].displayedItem then
			texture = select(5,GetItemInfoInstant(self.anvilItems[i].displayedItem))
		elseif self.anvilItems[i].itemID then
			texture = select(5,GetItemInfoInstant(self.anvilItems[i].itemID))
		else
			texture = self.anvilItems[i].slotTexture
		end
		self.anvilItems[i].Icon:SetTexture(texture);
		self.anvilItems[i].Icon:SetDesaturated(false);
		self.anvilItems[i].Icon:SetAlpha(1);
		self.anvilItems[i].IconBorder:SetDesaturation(0);
		self.anvilItems[i].IconBorder:SetAlpha(1);
		self.anvilItems[i]:Show();
	end
	if AnvilWardrobeCollectionDressUpFrame.DressUpModel.playOrPause == "play" then
		AnvilWardrobeCollectionDressUpFrame.DressUpModel:SetAnimation(2)
	elseif AnvilWardrobeCollectionDressUpFrame.DressUpModel.playOrPause == "pause" then
		AnvilWardrobeCollectionDressUpFrame.DressUpModel:SetAnimation(3)
	end
end

function AnvilItemTooltips(self)
	self:UnregisterEvent("GET_ITEM_INFO_RECEIVED")
	GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
	self.UpdateTooltip = AnvilItemTooltips;
	local name, quality
	if self.displayedItem then
		if GetItemInfo(self.displayedItem) then
			name, _, quality = GetItemInfo(self.displayedItem)
		else
			self:RegisterEvent("GET_ITEM_INFO_RECEIVED", AnvilItemTooltips)
			return
		end
	elseif self.itemID then
		if GetItemInfo(self.itemID) then
			name, _, quality = GetItemInfo(self.itemID)
		else
			self:RegisterEvent("GET_ITEM_INFO_RECEIVED", AnvilItemTooltips)
			return
		end
	else
		return
	end
	GameTooltip:ClearLines()
	GameTooltip:AddDoubleLine(self.slotName, "Currently Displayed As:", 1, 1, 1, 1, 1, 1)
	GameTooltip:AddLine("|c"..select(4,GetItemQualityColor(quality))..name, true)
	GameTooltip:Show()
end

function AnvilWardrobeItemsCollectionMixin:OnHide()
	self:UnregisterEvent("TRANSMOGRIFY_UPDATE");
	self:UnregisterEvent("PLAYER_EQUIPMENT_CHANGED");
	self:UnregisterEvent("TRANSMOGRIFY_SUCCESS");

	StaticPopup_Hide("TRANSMOG__WARNING");

	AnvilWardrobeCollectionFrame_ClearSearch(LE_TRANSMOG_SEARCH_TYPE_ITEMS);

	for i = 1, #self.Models do
		self.Models[i]:SetKeepModelOnHide(false);
	end

	self.visualsList = nil;
	self.filteredVisualsList = nil;
end

function AnvilWardrobeCollectionFrame_OnShow(self)
	SetPortraitToTexture(AnvilCollectionsJournalPortrait, "Interface\\Icons\\inv_chest_cloth_17");

	self:RegisterEvent("TRANSMOG_COLLECTION_ITEM_UPDATE");
	self:RegisterUnitEvent("UNIT_MODEL_CHANGED", "player");
	self:RegisterEvent("TRANSMOG_SEARCH_UPDATED");
	self:RegisterEvent("SEARCH_DB_LOADED");
	self:RegisterEvent("PLAYER_LEVEL_UP");
	self:RegisterEvent("SKILL_LINES_CHANGED");
	self:RegisterEvent("UPDATE_FACTION");
	self:RegisterEvent("SPELLS_CHANGED");
	self:RegisterEvent("UI_SCALE_CHANGED");
	self:RegisterEvent("DISPLAY_SIZE_CHANGED");
	self:RegisterEvent("TRANSMOG_COLLECTION_CAMERA_UPDATE");

	local hasAlternateForm, inAlternateForm = HasAlternateForm();
	self.inAlternateForm = inAlternateForm;

	AnvilWardrobeCollectionFrame_UpdateUsableAppearances();

	AnvilWardrobeCollectionFrame_SetTab(self.selectedCollectionTab);
	AnvilWardrobeCollectionFrame_UpdateTabButtons();
	AnvilWardrobeCollectionDressUpFrame.DressUpModel.controlFrame:ClearAllPoints()
	AnvilWardrobeCollectionDressUpFrame.DressUpModel.controlFrame:SetPoint("TOP", AnvilWardrobeCollectionDressUpControlButtons, "TOP")
	AnvilWardrobeCollectionDressUpFrame.DressUpModel.controlFrame:SetScale(1.5)
	AnvilWardrobeCollectionDressUpFrame.DressUpModel:SetUnit("player")
end

function AnvilWardrobeCollectionFrame_OnHide(self)
	self:UnregisterEvent("TRANSMOG_COLLECTION_ITEM_UPDATE");
	self:UnregisterEvent("UNIT_MODEL_CHANGED");
	self:UnregisterEvent("TRANSMOG_SEARCH_UPDATED");
	self:UnregisterEvent("SEARCH_DB_LOADED");
	self:UnregisterEvent("PLAYER_LEVEL_UP");
	self:UnregisterEvent("SKILL_LINES_CHANGED");
	self:UnregisterEvent("UPDATE_FACTION");
	self:UnregisterEvent("SPELLS_CHANGED");
	self:UnregisterEvent("UI_SCALE_CHANGED");
	self:UnregisterEvent("DISPLAY_SIZE_CHANGED");
	self:UnregisterEvent("TRANSMOG_COLLECTION_CAMERA_UPDATE");
	C_TransmogCollection.EndSearch();
	self.jumpToVisualID = nil;
end

function AnvilWardrobeCollectionFrame_UpdateTabButtons()
	AnvilWardrobeCollectionFrame.SetsTab.FlashFrame:SetShown(C_TransmogSets.GetLatestSource() ~= NO_TRANSMOG_SOURCE_ID);
end

function AnvilWardrobeItemsCollectionMixin:OnMouseWheel(delta)
	self.PagingFrame:OnMouseWheel(delta);
end

function AnvilWardrobeItemsCollectionMixin:CanHandleKey(key)
	if ((key == WARDROBE_PREV_VISUAL_KEY or key == WARDROBE_NEXT_VISUAL_KEY or key == WARDROBE_UP_VISUAL_KEY or key == WARDROBE_DOWN_VISUAL_KEY)) then
		return true;
	end
	return false;
end

function AnvilWardrobeItemsCollectionMixin:HandleKey(key)
	local _, appliedVisualID = AnvilWardrobeCollectionFrame_GetInfoForEquippedSlot(self.activeSlot, self.transmogType);
	local visualIndex;
	local visualsList = self:GetFilteredVisualsList();
	for i = 1, #visualsList do
		if ( visualsList[i].visualID == appliedVisualID ) then
			visualIndex = i;
			break;
		end
	end
	if ( visualIndex ) then
		visualIndex = AnvilWardrobeUtils_GetAdjustedDisplayIndexFromKeyPress(self, visualIndex, #visualsList, key);
		self:SelectVisual(visualsList[visualIndex].visualID);
		self.jumpToVisualID = visualsList[visualIndex].visualID;
		self:ResetPage();
	end
end

function AnvilWardrobeCollectionFrame_OnKeyDown(self, key)
	if ( self.tooltipCycle and key == WARDROBE_CYCLE_KEY ) then
		self:SetPropagateKeyboardInput(false);
		if ( IsShiftKeyDown() ) then
			self.tooltipSourceIndex = self.tooltipSourceIndex - 1;
		else
			self.tooltipSourceIndex = self.tooltipSourceIndex + 1;
		end
		self.tooltipContentFrame:RefreshAppearanceTooltip();
	elseif ( key == WARDROBE_PREV_VISUAL_KEY or key == WARDROBE_NEXT_VISUAL_KEY or key == WARDROBE_UP_VISUAL_KEY or key == WARDROBE_DOWN_VISUAL_KEY ) then
		if ( self.activeFrame:CanHandleKey(key) ) then
			self:SetPropagateKeyboardInput(false);
			self.activeFrame:HandleKey(key);
		else
			self:SetPropagateKeyboardInput(true);
		end
	else
		self:SetPropagateKeyboardInput(true);
	end
end

function AnvilWardrobeClearSelections()
	for i=1, #(AnvilWardrobeCollectionFrame.ItemsCollectionFrame.anvilSlots) do
		AnvilWardrobeCollectionFrame.ItemsCollectionFrame.anvilSlots[i].selectedPage = nil
		AnvilWardrobeCollectionFrame.ItemsCollectionFrame.anvilSlots[i].selectedButton = nil
	end
end

function AnvilWardrobeResizeAppearancesJournal()
	local widthModifier = 3*(Anvil.db.global.collectionsWidth-1)
-- Declare a local so all of this is a little easier to read.  Potentially eliminate to save memory once this function is set in stone?
	local anvilFrame = AnvilWardrobeCollectionFrame.ItemsCollectionFrame
	anvilFrame.NUM_COLS = 2+widthModifier;
	anvilFrame.PAGE_SIZE = anvilFrame.NUM_ROWS * anvilFrame.NUM_COLS;
	if anvilFrame.Models then
		wipe(anvilFrame.Models)
	else
		anvilFrame.Models = {}
	end
	for i=1, 8+4*widthModifier do
		if not _G["AnvilAppearancesModel"..i] then
			_G["AnvilAppearancesModel"..i] = CreateFrame("DressUpModel", "AnvilAppearancesModel"..i, anvilFrame, "AnvilWardrobeItemsModelTemplate")
		end
		_G["AnvilAppearancesModel"..i]:SetID(i)
		_G["AnvilAppearancesModel"..i]:Show()
		tinsert(anvilFrame.Models, _G["AnvilAppearancesModel"..i])
	end
	for i=9+4*widthModifier, 56 do
		if _G["AnvilAppearancesModel"..i] then
			_G["AnvilAppearancesModel"..i]:Hide()
		end
	end
	for i=1, 4 do
		for j=1, 2+widthModifier do
			anvilFrame.Models[(i-1)*(2+widthModifier)+j]:SetPoint("CENTER", anvilFrame, "TOPLEFT", j*87+14, -i*119+28)
		end
	end
end

function AnvilWardrobeItemsCollectionMixin:ChangeModelsSlot(oldSlot, newSlot)
	AnvilWardrobeCollectionFrame.updateOnModelChanged = nil;
	AnvilWardrobeResizeAppearancesJournal()
	local undressSlot, reloadModel;
	local newSlotIsArmor = AnvilWardrobeUtils_GetArmorCategoryIDFromSlot(newSlot);
	if ( newSlotIsArmor ) then
		local oldSlotIsArmor = oldSlot and AnvilWardrobeUtils_GetArmorCategoryIDFromSlot(oldSlot);
		if ( oldSlotIsArmor ) then
			if ( WARDROBE_MODEL_SETUP[oldSlot].useTransmogSkin ~= WARDROBE_MODEL_SETUP[newSlot].useTransmogSkin ) then
				reloadModel = true;
			else
				undressSlot = true;
			end
		else
			reloadModel = true;
		end
	end
	if ( reloadModel and not self.Models[1]:CanSetUnit("player") ) then
		AnvilWardrobeCollectionFrame.updateOnModelChanged = true;
		for i = 1, #self.Models do
			self.Models[i]:ClearModel();
		end
		return;
	end
	for i = 1, #self.Models do
		local model = self.Models[i];
		if ( undressSlot ) then
			local changedOldSlot = false;
			for slot, equip in pairs(WARDROBE_MODEL_SETUP[newSlot].slots) do
				if ( equip ~= WARDROBE_MODEL_SETUP[oldSlot].slots[slot] ) then
					if ( equip ) then
						model:TryOn(WARDROBE_MODEL_SETUP_GEAR[slot]);
					else
						model:UndressSlot(GetInventorySlotInfo(slot));
					end
					if ( slot == oldSlot ) then
						changedOldSlot = true;
					end
				end
			end
			if ( not changedOldSlot ) then
				local slotID = GetInventorySlotInfo(oldSlot);
				model:UndressSlot(slotID);
			end
		elseif ( reloadModel ) then
			model:Reload(newSlot);
		end
		model.visualInfo = nil;
		end
	self.illusionWeaponVisualID = nil;
end

function AnvilWardrobeItemsCollectionMixin:RefreshModelsSlot()
	AnvilWardrobeResizeAppearancesJournal()
	for i = 1, #self.Models do
		self.Models[i]:Reload(self:GetActiveSlot());
		self.Models[i].visualInfo = nil;
	end
end

function AnvilWardrobeItemsCollectionMixin:RefreshCameras()
	if ( self:IsShown() ) then
		for i, model in ipairs(self.Models) do
			model:RefreshCamera();
			if ( model.cameraID ) then
				Model_ApplyUICamera(model, model.cameraID);
			end
		end
	end
end

function AnvilWardrobeItemsCollectionMixin:OnUnitModelChangedEvent()
	if ( self.Models[1]:CanSetUnit("player") ) then
		self:ChangeModelsSlot(nil, self:GetActiveSlot());
		self:UpdateItems();
		return true;
	else
		return false;
	end
end

function AnvilWardrobeUtils_IsCategoryRanged(category)
	return (category == LE_TRANSMOG_COLLECTION_TYPE_BOW) or (category == LE_TRANSMOG_COLLECTION_TYPE_GUN) or (category == LE_TRANSMOG_COLLECTION_TYPE_CROSSBOW);
end

function AnvilWardrobeUtils_GetArmorCategoryIDFromSlot(slot)
	for i = 1, #TRANSMOG_SLOTS do
		if ( TRANSMOG_SLOTS[i].slot == slot ) then
			return TRANSMOG_SLOTS[i].armorCategoryID;
		end
	end
end

function AnvilWardrobeUtils_GetValidIndexForNumSources(index, numSources)
	index = index - 1;
	if ( index < 0 ) then
		index = numSources + index;
	end
	return mod(index, numSources) + 1;
end

local function GetPage(entryIndex, pageSize)
	return floor((entryIndex-1) / pageSize) + 1;
end

function AnvilWardrobeUtils_GetAdjustedDisplayIndexFromKeyPress(contentFrame, index, numEntries, key)
	if ( key == WARDROBE_PREV_VISUAL_KEY ) then
		index = index - 1;
		if ( index < 1 ) then
			index = numEntries;
		end
	elseif ( key == WARDROBE_NEXT_VISUAL_KEY ) then
		index = index + 1;
		if ( index > numEntries ) then
			index = 1;
		end
	elseif ( key == WARDROBE_DOWN_VISUAL_KEY or key == WARDROBE_UP_VISUAL_KEY ) then
		local direction = 1;
		if ( key == WARDROBE_UP_VISUAL_KEY ) then
			direction = -1;
		end

		local newIndex = index;
		newIndex = newIndex + contentFrame.NUM_COLS * direction;
		if ( GetPage(newIndex, contentFrame.PAGE_SIZE) ~= contentFrame.PagingFrame:GetCurrentPage() or newIndex > numEntries ) then
			newIndex = index + contentFrame.PAGE_SIZE * -direction;
			while ( GetPage(newIndex, contentFrame.PAGE_SIZE) ~= contentFrame.PagingFrame:GetCurrentPage() or newIndex > numEntries ) do
				newIndex = newIndex + contentFrame.NUM_COLS * direction;
				if ( newIndex < 1 or newIndex > numEntries + contentFrame.PAGE_SIZE ) then
					newIndex = 1;
					break;
				end
			end
		end
		index = newIndex;
	end
	return index;
end

function AnvilWardrobeItemsCollectionMixin:GetActiveSlot()
	return self.activeSlot;
end

function AnvilWardrobeItemsCollectionMixin:GetActiveCategory()
	return self.activeCategory;
end

function AnvilWardrobeItemsCollectionMixin:IsValidWeaponCategoryForSlot(categoryID, slot)
	local name, isWeapon, canEnchant, canMainHand, canOffHand = C_TransmogCollection.GetCategoryInfo(categoryID);
	if ( name and isWeapon ) then
		if ( (slot == "MAINHANDSLOT" and canMainHand) or (slot == "SECONDARYHANDSLOT" and canOffHand) ) then
			return true;
		end
	end
	return false;
end

function AnvilWardrobeItemsCollectionMixin:SetActiveSlot(slot, transmogType, category)
	local previousSlot = self.activeSlot;
	self.activeSlot = slot;
	self.transmogType = transmogType;

	if ( not category ) then
		if ( transmogType == LE_TRANSMOG_TYPE_ILLUSION ) then
			category = nil;
		elseif ( transmogType == LE_TRANSMOG_TYPE_APPEARANCE ) then
			local useLastWeaponCategory = (slot == "MAINHANDSLOT" or slot == "SECONDARYHANDSLOT") and
											self.lastWeaponCategory and
											self:IsValidWeaponCategoryForSlot(self.lastWeaponCategory, slot);
			if ( useLastWeaponCategory ) then
				category = self.lastWeaponCategory;
			else
				local appliedSourceID, appliedVisualID = AnvilWardrobeCollectionFrame_GetInfoForEquippedSlot(self.activeSlot, self.transmogType);
				if ( appliedSourceID ~= NO_TRANSMOG_SOURCE_ID ) then
					category = C_TransmogCollection.GetAppearanceSourceInfo(appliedSourceID);
				end
			end
			if ( not category ) then
				if ( slot == "MAINHANDSLOT" or slot == "SECONDARYHANDSLOT" ) then
					for categoryID = FIRST_TRANSMOG_COLLECTION_WEAPON_TYPE, LAST_TRANSMOG_COLLECTION_WEAPON_TYPE do
						if ( self:IsValidWeaponCategoryForSlot(categoryID, slot) ) then
							category = categoryID;
							break;
						end
					end
				else
					category = AnvilWardrobeUtils_GetArmorCategoryIDFromSlot(slot);
				end
			end
		end
	end

	if ( previousSlot ~= slot ) then
		self:ChangeModelsSlot(previousSlot, slot);
	end
	if ( category ~= self.activeCategory or slot ~= previousSlot ) then
		CloseDropDownMenus();
		self:SetActiveCategory(category);
	end
end

function AnvilWardrobeItemsCollectionMixin:UpdateWeaponDropDown()
	local dropdown = self.WeaponDropDown;
	local name, isWeapon;
	if ( self.transmogType == LE_TRANSMOG_TYPE_APPEARANCE ) then
		name, isWeapon = C_TransmogCollection.GetCategoryInfo(self.activeCategory);
	end
	if ( not isWeapon ) then
		dropdown:Hide()
		UIDropDownMenu_DisableDropDown(dropdown);
		UIDropDownMenu_SetText(dropdown, "");
	else
		dropdown:Show();
		UIDropDownMenu_SetSelectedValue(dropdown, self.activeCategory);
		UIDropDownMenu_SetText(dropdown, name);
		local validCategories = AnvilWardrobeCollectionFrameWeaponDropDown_Init(dropdown);
		if ( validCategories > 1 ) then
			UIDropDownMenu_EnableDropDown(dropdown);
		else
			UIDropDownMenu_DisableDropDown(dropdown);
		end
	end
end

function AnvilWardrobeItemsCollectionMixin:SetActiveCategory(category)
	self.activeCategory = category;
	if ( self.transmogType == LE_TRANSMOG_TYPE_APPEARANCE ) then
		C_TransmogCollection.SetSearchAndFilterCategory(category);
		local name, isWeapon = C_TransmogCollection.GetCategoryInfo(category);
		if ( isWeapon ) then
			self.lastWeaponCategory = category;
		end
	end
	self:RefreshVisualsList();
	self:UpdateWeaponDropDown();

	local slotButtons = self.SlotsFrame.Buttons;
	for i = 1, #slotButtons do
		local button = slotButtons[i];
		button.SelectedTexture:SetShown(button.slot == self.activeSlot and button.transmogType == self.transmogType);
	end

	self:ResetPage();
	AnvilWardrobeCollectionFrame_SwitchSearchCategory();
end

function AnvilWardrobeItemsCollectionMixin:ResetPage()
	local page = 1;
	local selectedVisualID = NO_TRANSMOG_VISUAL_ID;
	if ( C_TransmogCollection.IsSearchInProgress(AnvilWardrobeCollectionFrame.activeFrame.searchType) ) then
		self.resetPageOnSearchUpdated = true;
	else
		if ( self.jumpToVisualID ) then
			selectedVisualID = self.jumpToVisualID;
			self.jumpToVisualID = nil;
		elseif ( self.jumpToLatestAppearanceID ) then
			selectedVisualID = self.jumpToLatestAppearanceID;
			self.jumpToLatestAppearanceID = nil;
		end
	end
	if ( selectedVisualID and selectedVisualID ~= NO_TRANSMOG_VISUAL_ID ) then
		local visualsList = self:GetFilteredVisualsList();
		for i = 1, #visualsList do
			if ( visualsList[i].visualID == selectedVisualID ) then
				page = GetPage(i, self.PAGE_SIZE);
				break;
			end
		end
	end
	self.PagingFrame:SetCurrentPage(page);
	self:UpdateItems();
end

function AnvilWardrobeItemsCollectionMixin:FilterVisuals()
	local visualsList = self.visualsList;
	local filteredVisualsList = { };
	for i = 1, #visualsList do
		if ( not visualsList[i].isHideVisual ) then
			tinsert(filteredVisualsList, visualsList[i]);
		end
	end
	self.filteredVisualsList = filteredVisualsList;
end

function AnvilWardrobeItemsCollectionMixin:SortVisuals()
	local comparison = function(source1, source2)
		if ( source1.isCollected ~= source2.isCollected ) then
			return source1.isCollected;
		end
		if ( source1.isUsable ~= source2.isUsable ) then
			return source1.isUsable;
		end
		if ( source1.isFavorite ~= source2.isFavorite ) then
			return source1.isFavorite;
		end
		if ( source1.isHideVisual ~= source2.isHideVisual ) then
			return source1.isHideVisual;
		end
		if ( source1.hasActiveRequiredHoliday ~= source2.hasActiveRequiredHoliday ) then
			return source1.hasActiveRequiredHoliday;
		end
		if ( source1.uiOrder and source2.uiOrder ) then
			return source1.uiOrder > source2.uiOrder;
		end
		return source1.sourceID > source2.sourceID;
	end

	table.sort(self.filteredVisualsList, comparison);
end

function AnvilWardrobeCollectionFrame_GetInfoForEquippedSlot(slot, transmogType)
	local baseSourceID, baseVisualID, appliedSourceID, appliedVisualID, pendingSourceID, pendingVisualID, hasPendingUndo = C_Transmog.GetSlotVisualInfo(GetInventorySlotInfo(slot), transmogType);
	if ( appliedSourceID == NO_TRANSMOG_SOURCE_ID ) then
		appliedSourceID = baseSourceID;
		appliedVisualID = baseVisualID;
	end
	return appliedSourceID, appliedVisualID;
end

function AnvilWardrobeCollectionFrame_GetWeaponInfoForEnchant(slot)
	local appearanceSourceID = AnvilWardrobeCollectionDressUpFrame.DressUpModel:GetSlotTransmogSources(GetInventorySlotInfo(slot));
	if ( AnvilWardrobeCollectionFrame_CanEnchantSource(appearanceSourceID) ) then
		local _, appearanceVisualID = C_TransmogCollection.GetAppearanceSourceInfo(appearanceSourceID);
		return appearanceSourceID, appearanceVisualID;
	end

	local appearanceSourceID = C_TransmogCollection.GetIllusionFallbackWeaponSource();
	local _, appearanceVisualID = C_TransmogCollection.GetAppearanceSourceInfo(appearanceSourceID);
	return appearanceSourceID, appearanceVisualID;
end

function AnvilWardrobeCollectionFrame_CanEnchantSource(sourceID)
	local _, visualID, canEnchant = C_TransmogCollection.GetAppearanceSourceInfo(sourceID);
	if ( canEnchant ) then
		AnvilWardrobeCollectionFrame.ItemsCollectionFrame.HiddenModel:SetItemAppearance(visualID);
		return AnvilWardrobeCollectionFrame.ItemsCollectionFrame.HiddenModel:HasAttachmentPoints();
	end
	return false;
end

function AnvilWardrobeItemsCollectionMixin:UpdateItems()
	local isArmor;
	local cameraID;
	local appearanceVisualID;
	local changeModel = false;
	if ( self.transmogType == LE_TRANSMOG_TYPE_ILLUSION ) then
		local appearanceSourceID;
		appearanceSourceID, appearanceVisualID = AnvilWardrobeCollectionFrame_GetWeaponInfoForEnchant(self.activeSlot);
		cameraID = C_TransmogCollection.GetAppearanceCameraIDBySource(appearanceSourceID);
		if ( appearanceVisualID ~= self.illusionWeaponVisualID ) then
			self.illusionWeaponVisualID = appearanceVisualID;
			changeModel = true;
		end
	else
		local _, isWeapon = C_TransmogCollection.GetCategoryInfo(self.activeCategory);
		isArmor = not isWeapon;
	end
	local tutorialAnchorFrame;
	local checkTutorialFrame = (self.transmogType == LE_TRANSMOG_TYPE_APPEARANCE)
								and not GetCVarBitfield("closedInfoFrames", LE_FRAME_TUTORIAL_TRANSMOG_MODEL_CLICK);
	local indexOffset = (self.PagingFrame:GetCurrentPage() - 1) * self.PAGE_SIZE;
	for i = 1, self.PAGE_SIZE do
		local model = self.Models[i];
		local index = i + indexOffset;
		local visualInfo = self.filteredVisualsList[index];
		if ( visualInfo ) then
			model:Show();
			if ( self.transmogType == LE_TRANSMOG_TYPE_APPEARANCE ) then
				cameraID = C_TransmogCollection.GetAppearanceCameraID(visualInfo.visualID);
			end
			if ( model.cameraID ~= cameraID ) then
				Model_ApplyUICamera(model, cameraID);
				model.cameraID = cameraID
			end
			if ( visualInfo ~= model.visualInfo or changeModel ) then
				if ( isArmor ) then
					local sourceID = self:GetAnAppearanceSourceFromVisual(visualInfo.visualID);
					model:TryOn(sourceID);
				elseif ( appearanceVisualID ) then
					model:SetItemAppearance(appearanceVisualID, visualInfo.visualID);
				else
					model:SetItemAppearance(visualInfo.visualID);
				end
			end
			model.visualInfo = visualInfo;
			local whichAnvilSlot
			for i=1, #(self.anvilSlots) do
				if self.anvilSlots[i].slotName == self.activeSlot then
					whichAnvilSlot = i
				end
			end
			if (self.anvilSlots[whichAnvilSlot].selectedPage == self.PagingFrame:GetCurrentPage() and self.anvilSlots[whichAnvilSlot].selectedButton == i) then
				model.TransmogStateTexture:Show();
			else
				model.TransmogStateTexture:Hide();
			end

			if ( not visualInfo.isCollected ) then
				model.Border:SetAtlas("transmog-wardrobe-border-uncollected");
			elseif ( not visualInfo.isUsable ) then
				model.Border:SetAtlas("transmog-wardrobe-border-unusable");
			else
				model.Border:SetAtlas("transmog-wardrobe-border-collected");
			end

			if ( C_TransmogCollection.IsNewAppearance(visualInfo.visualID) ) then
				model.NewString:Show();
				model.NewGlow:Show();
			else
				model.NewString:Hide();
				model.NewGlow:Hide();
			end
			model.Favorite.Icon:SetShown(visualInfo.isFavorite);
			model.HideVisual.Icon:SetShown(visualInfo.isHideVisual);

			if ( GameTooltip:GetOwner() == model ) then
				model:OnEnter();
			end

			if ( checkTutorialFrame ) then
				if ( i < self.NUM_COLS and not AnvilWardrobeCollectionFrame.tutorialVisualID and visualInfo.isCollected and not visualInfo.isHideVisual ) then
					tutorialAnchorFrame = model;
				elseif ( AnvilWardrobeCollectionFrame.tutorialVisualID and AnvilWardrobeCollectionFrame.tutorialVisualID == visualInfo.visualID ) then
					tutorialAnchorFrame = model;
				end
			end
		else
			model:Hide();
			model.visualInfo = nil;
		end
	end
	self:UpdateProgressBar();
	if ( checkTutorialFrame ) then
		if ( C_TransmogCollection.HasFavorites() ) then
			SetCVarBitfield("closedInfoFrames", LE_FRAME_TUTORIAL_TRANSMOG_MODEL_CLICK, true);
			tutorialAnchorFrame = nil;
		elseif ( tutorialAnchorFrame ) then
			if ( not AnvilWardrobeCollectionFrame.tutorialVisualID ) then
				AnvilWardrobeCollectionFrame.tutorialVisualID = tutorialAnchorFrame.visualInfo.visualID;
			end
			if ( AnvilWardrobeCollectionFrame.tutorialVisualID ~= tutorialAnchorFrame.visualInfo.visualID ) then
				tutorialAnchorFrame = nil;
			end
		end
	end
	if ( tutorialAnchorFrame ) then
		self.HelpBox:SetPoint("TOP", tutorialAnchorFrame, "BOTTOM", 0, -22);
		self.HelpBox:Show();
	else
		self.HelpBox:Hide();
	end
end

function AnvilWardrobeItemsCollectionMixin:UpdateProgressBar()
	local collected, total;
	if ( self.transmogType == LE_TRANSMOG_TYPE_ILLUSION ) then
		total = #self.visualsList;
		collected = 0;
		for i, illusion in ipairs(self.visualsList) do
			if ( illusion.isCollected ) then
				collected = collected + 1;
			end
		end
	else
		collected = C_TransmogCollection.GetCategoryCollectedCount(self.activeCategory);
		total = C_TransmogCollection.GetCategoryTotal(self.activeCategory);
	end
	AnvilWardrobeCollectionFrame_UpdateProgressBar(collected, total);
end

function AnvilWardrobeCollectionFrame_UpdateProgressBar(value, max)
	AnvilWardrobeCollectionFrame.progressBar:SetMinMaxValues(0, max);
	AnvilWardrobeCollectionFrame.progressBar:SetValue(value);
	AnvilWardrobeCollectionFrame.progressBar.text:SetFormattedText(HEIRLOOMS_PROGRESS_FORMAT, value, max);
end

function AnvilWardrobeCollectionFrame_SortSources(sources, primaryVisualID, primarySourceID)
	local comparison = function(source1, source2)
		if ( primaryVisualID and source1.visualID ~= source2.visualID ) then
			return source1.visualID == primaryVisualID;
		end

		if ( source1.isCollected ~= source2.isCollected ) then
			return source1.isCollected;
		end

		if ( primarySourceID ) then
			local source1IsPrimary = (source1.sourceID == primarySourceID);
			local source2IsPrimary = (source2.sourceID == primarySourceID);
			if ( source1IsPrimary ~= source2IsPrimary ) then
				return source1IsPrimary;
			end
		end

		if ( source1.quality and source2.quality ) then
			if ( source1.quality ~= source2.quality ) then
				return source1.quality > source2.quality;
			end
		else
			return source1.quality;
		end

		return source1.sourceID > source2.sourceID;
	end
	table.sort(sources, comparison);
	return sources;
end

function AnvilWardrobeCollectionFrame_GetSortedAppearanceSources(visualID)
	local sources = C_TransmogCollection.GetAppearanceSources(visualID);
	return AnvilWardrobeCollectionFrame_SortSources(sources);
end

function AnvilWardrobeItemsCollectionMixin:RefreshVisualsList()
	if ( self.transmogType == LE_TRANSMOG_TYPE_ILLUSION ) then
		self.visualsList = C_TransmogCollection.GetIllusions();
	else
		self.visualsList = C_TransmogCollection.GetCategoryAppearances(self.activeCategory);
	end
	self:FilterVisuals();
	self:SortVisuals();
	self.PagingFrame:SetMaxPages(ceil(#self.filteredVisualsList / self.PAGE_SIZE));
end

function AnvilWardrobeItemsCollectionMixin:GetFilteredVisualsList()
	return self.filteredVisualsList;
end

function AnvilWardrobeItemsCollectionMixin:GetAnAppearanceSourceFromVisual(visualID, mustBeUsable)
	local sourceID = self:GetChosenVisualSource(visualID);
	if ( sourceID == NO_TRANSMOG_SOURCE_ID ) then
		local sources = AnvilWardrobeCollectionFrame_GetSortedAppearanceSources(visualID);
		for i = 1, #sources do
			if ( not mustBeUsable or not sources[i].useError ) then
				sourceID = sources[i].sourceID;
				break;
			end
		end
	end
	return sourceID;
end

function AnvilWardrobeItemsCollectionMixin:SelectVisual(visualID)
	local sourceID;
	if ( self.transmogType == LE_TRANSMOG_TYPE_APPEARANCE ) then
		sourceID = self:GetAnAppearanceSourceFromVisual(visualID, true);
	else
		local visualsList = self:GetFilteredVisualsList();
		for i = 1, #visualsList do
			if ( visualsList[i].visualID == visualID ) then
				sourceID = visualsList[i].sourceID;
				break;
			end
		end
	end
	local slotID = GetInventorySlotInfo(self.activeSlot);
	C_Transmog.SetPending(slotID, self.transmogType, sourceID);
	PlaySound(SOUNDKIT.UI_TRANSMOG_ITEM_CLICK);
end

function AnvilWardrobeCollectionFrame_OpenTransmogLink(link, transmogType)
	local linkType, id = strsplit(":", link);
	if ( linkType == "transmogappearance" ) then
		local sourceID = tonumber(id);
		if ( not AnvilWardrobeCollectionFrame:IsVisible() ) then
			ToggleAnvilCollectionsJournal(5);
		end
		AnvilWardrobeCollectionFrame_SetTab(TAB_ITEMS);
		AnvilWardrobeCollectionFrame.ItemsCollectionFrame:GoToSourceID(sourceID, nil, LE_TRANSMOG_TYPE_APPEARANCE);
	elseif ( linkType == "transmogset") then
		local setID = tonumber(id);
		if ( not AnvilWardrobeCollectionFrame:IsVisible() ) then
			ToggleAnvilCollectionsJournal(5);
		end
		AnvilWardrobeCollectionFrame_SetTab(TAB_SETS);
		AnvilWardrobeCollectionFrame.SetsCollectionFrame:SelectSet(setID);
	end
end

function AnvilWardrobeItemsCollectionMixin:GoToSourceID(sourceID, slot, transmogType, forceGo)
	local categoryID, visualID;
	if ( transmogType == LE_TRANSMOG_TYPE_APPEARANCE ) then
		categoryID, visualID = C_TransmogCollection.GetAppearanceSourceInfo(sourceID);
		slot = slot or AnvilWardrobeCollectionFrame_GetSlotFromCategoryID(categoryID);
	elseif ( transmogType == LE_TRANSMOG_TYPE_ILLUSION ) then
		visualID = C_TransmogCollection.GetIllusionSourceInfo(sourceID);
		slot = slot or "MAINHANDSLOT";
	end
	if ( visualID or forceGo ) then
		self.jumpToVisualID = visualID;
		if ( self.activeCategory ~= categoryID or self.activeSlot ~= slot ) then
			self:SetActiveSlot(slot, transmogType, categoryID);
		else
			self:ResetPage();
		end
	end
end

function AnvilWardrobeItemsCollectionMixin:SetAppearanceTooltip(frame)
	GameTooltip:SetOwner(frame, "ANCHOR_RIGHT");
	self.tooltipVisualID = frame.visualInfo.visualID;
	self:RefreshAppearanceTooltip();
end

function AnvilWardrobeItemsCollectionMixin:RefreshAppearanceTooltip()
	if ( not self.tooltipVisualID ) then
		return;
	end
	local sources = AnvilWardrobeCollectionFrame_GetSortedAppearanceSources(self.tooltipVisualID);
	local chosenSourceID = self:GetChosenVisualSource(self.tooltipVisualID);
	AnvilWardrobeCollectionFrame_SetAppearanceTooltip(self, sources, chosenSourceID);
end

function AnvilWardrobeItemsCollectionMixin:ClearAppearanceTooltip()
	self.tooltipVisualID = nil;
	AnvilWardrobeCollectionFrame_HideAppearanceTooltip();
end

function AnvilWardrobeCollectionFrame_GetSlotFromCategoryID(categoryID)
	local slot;
	for i = 1, #TRANSMOG_SLOTS do
		if ( TRANSMOG_SLOTS[i].armorCategoryID == categoryID ) then
			slot = TRANSMOG_SLOTS[i].slot;
			break;
		end
	end
	if ( not slot ) then
		local name, isWeapon, canEnchant, canMainHand, canOffHand = C_TransmogCollection.GetCategoryInfo(categoryID);
		if ( canMainHand ) then
			slot = "MAINHANDSLOT";
		elseif ( canOffHand ) then
			slot = "SECONDARYHANDSLOT";
		end
	end
	return slot;
end

AnvilWardrobeItemsModelMixin = { };

function AnvilWardrobeItemsModelMixin:OnLoad()
	self:SetAutoDress(false);

	local lightValues = { enabled=true, omni=false, dirX=-1, dirY=1, dirZ=-1, ambIntensity=1.05, ambR=1, ambG=1, ambB=1, dirIntensity=0, dirR=1, dirG=1, dirB=1 };
	self:SetLight(lightValues.enabled, lightValues.omni, 
			lightValues.dirX, lightValues.dirY, lightValues.dirZ,
			lightValues.ambIntensity, lightValues.ambR, lightValues.ambG, lightValues.ambB,
			lightValues.dirIntensity, lightValues.dirR, lightValues.dirG, lightValues.dirB);
end

function AnvilWardrobeItemsModelMixin:OnModelLoaded()
	if ( self.cameraID ) then
		Model_ApplyUICamera(self, self.cameraID);
	end
end

function AnvilWardrobeItemsModelMixin:OnMouseDown(button)
	collectgarbage("collect")
	local parent = self:GetParent();
	local transmogType = self:GetParent().transmogType;
	local link, index, sources, weaponSourceID
	if transmogType ~= LE_TRANSMOG_TYPE_ILLUSION then
		sources = AnvilWardrobeCollectionFrame_GetSortedAppearanceSources(self.visualInfo.visualID);
		index = AnvilWardrobeUtils_GetValidIndexForNumSources(AnvilWardrobeCollectionFrame.tooltipSourceIndex, #sources);
		link = select(6, C_TransmogCollection.GetAppearanceSourceInfo(sources[index].sourceID));
	end
	if ( IsModifiedClick("CHATLINK") ) then
		if transmogType == LE_TRANSMOG_TYPE_ILLUSION then
			link = select(3, C_TransmogCollection.GetIllusionSourceInfo(self.visualInfo.sourceID));
		end
		if ( AnvilWardrobeCollectionFrame.tooltipSourceIndex or transmogType == LE_TRANSMOG_TYPE_ILLUSION ) then
			HandleModifiedItemClick(link);
		end
		return;
	end
	if ( button == "LeftButton" ) then
		CloseDropDownMenus();
		parent:SelectVisual(self.visualInfo.visualID);
		local slot = parent:GetActiveSlot();
		if ( transmogType == LE_TRANSMOG_TYPE_APPEARANCE ) then
			local sourceID = parent:GetAnAppearanceSourceFromVisual(self.visualInfo.visualID);
			if ( AnvilWardrobeUtils_IsCategoryRanged(parent:GetActiveCategory()) ) then
				slot = nil;
			end
			AnvilWardrobeCollectionDressUpFrame.DressUpModel:TryOn(sourceID)
		elseif ( transmogType == LE_TRANSMOG_TYPE_ILLUSION ) then
			weaponSourceID = AnvilWardrobeCollectionFrame_GetWeaponInfoForEnchant(slot);
			AnvilWardrobeCollectionDressUpFrame.DressUpModel:TryOn(weaponSourceID, slot, self.visualInfo.sourceID)
		end
		local whichAnvilSlot
		for i=1, #(parent.anvilSlots) do
			if parent.anvilSlots[i].slotName == parent.activeSlot then
				whichAnvilSlot = i
			end
		end
		if whichAnvilSlot == 13 then
			whichAnvilSlot = 12
		elseif whichAnvilSlot == 15 then
			whichAnvilSlot = 13
		end
		parent.anvilSlots[whichAnvilSlot].selectedButton = self:GetID()
		parent.anvilSlots[whichAnvilSlot].selectedPage = parent.PagingFrame:GetCurrentPage()
		self.TransmogStateTexture:Show();
		for i=1, parent.PAGE_SIZE do
			if i~=self:GetID() then
				parent.Models[i].TransmogStateTexture:Hide()
			end
		end
		if transmogType ~= LE_TRANSMOG_TYPE_ILLUSION then
			AnvilWardrobeCollectionFrame.ItemsCollectionFrame.anvilItems[whichAnvilSlot].displayedItem = link
		else
			AnvilWardrobeCollectionFrame.ItemsCollectionFrame.anvilItems[whichAnvilSlot].displayedEnchant = weaponSourceID
			AnvilWardrobeCollectionFrame.ItemsCollectionFrame.anvilItems[whichAnvilSlot].visualSourceID = self.visualInfo.sourceID
		end
		AnvilDrawDressUpButtons()
		return;
	elseif ( button == "RightButton" ) then
		local dropDown = parent.RightClickDropDown;
		if ( dropDown.activeFrame ~= self ) then
			CloseDropDownMenus();
		end
		if ( not self.visualInfo.isCollected or self.visualInfo.isHideVisual or transmogType == LE_TRANSMOG_TYPE_ILLUSION ) then
			return;
		end
		dropDown.activeFrame = self;
		ToggleDropDownMenu(1, nil, dropDown, self, -6, -3);
		PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_ON);
	end
end

function AnvilWardrobeItemsModelMixin:OnEnter()
	if ( not self.visualInfo ) then
		return;
	end
	ShowInspectCursor();
	if ( C_TransmogCollection.IsNewAppearance(self.visualInfo.visualID) ) then
		C_TransmogCollection.ClearNewAppearance(self.visualInfo.visualID);
		self.NewString:Hide();
		self.NewGlow:Hide();
	end
	if ( self:GetParent().transmogType == LE_TRANSMOG_TYPE_ILLUSION ) then
		local visualID, name = C_TransmogCollection.GetIllusionSourceInfo(self.visualInfo.sourceID);
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
		GameTooltip:SetText(name);
		if ( self.visualInfo.sourceText ) then
			GameTooltip:AddLine(self.visualInfo.sourceText, 1, 1, 1, 1);
		end
		GameTooltip:Show();
	else
		self:GetParent():SetAppearanceTooltip(self);
	end
end

function AnvilWardrobeItemsModelMixin:OnLeave()
	self:SetScript("OnUpdate", nil);
	ResetCursor();
	self:GetParent():ClearAppearanceTooltip();
end

function AnvilWardrobeItemsModelMixin:Reload(reloadSlot)
	if ( self:IsShown() ) then
		if ( WARDROBE_MODEL_SETUP[reloadSlot] ) then
			self:SetUseTransmogSkin(WARDROBE_MODEL_SETUP[reloadSlot].useTransmogSkin);
			self:SetUnit("player", false);
			self:SetDoBlend(false);
			for slot, equip in pairs(WARDROBE_MODEL_SETUP[reloadSlot].slots) do
				if ( equip ) then
					self:TryOn(WARDROBE_MODEL_SETUP_GEAR[slot]);
				end
			end
		end
		self:SetKeepModelOnHide(true);
		self.cameraID = nil;
		self.needsReload = nil;
	else
		self.needsReload = true;
	end
end

function AnvilWardrobeItemsModelMixin:OnShow()
	if ( self.needsReload ) then
		self:Reload(self:GetParent():GetActiveSlot());
	end
end

local function GetDropDifficulties(drop)
	local text = drop.difficulties[1];
	if ( text ) then
		for i = 2, #drop.difficulties do
			text = text..", "..drop.difficulties[i];
		end
	end
	return text;
end

function AnvilWardrobeCollectionFrame_HideAppearanceTooltip()
	AnvilWardrobeCollectionFrame.tooltipContentFrame = nil;
	AnvilWardrobeCollectionFrame.tooltipCycle = nil;
	AnvilWardrobeCollectionFrame.tooltipSourceIndex = nil;
	GameTooltip:Hide();
end

function AnvilWardrobeCollectionFrame_GetDefaultSourceIndex(sources, primarySourceID)
	local collectedSourceIndex;
	local unusableSourceIndex;
	local uncollectedSourceIndex;

	for i, sourceInfo in ipairs(sources) do
		if ( sourceInfo.isCollected ) then
			if ( sourceInfo.useError ) then
				if ( not unusableSourceIndex or primarySourceID == sourceInfo.sourceID ) then
					unusableSourceIndex = i;
				end
			else
				if ( primarySourceID == sourceInfo.sourceID ) then
					collectedSourceIndex = i;
					break;
				elseif ( not collectedSourceIndex ) then
					collectedSourceIndex = i;
					if ( primarySourceID == NO_TRANSMOG_SOURCE_ID ) then
						break;
					end
				end
			end
		else
			if ( not uncollectedSourceIndex or primarySourceID == sourceInfo.sourceID ) then
				uncollectedSourceIndex = i;
			end
		end
	end
	return collectedSourceIndex or unusableSourceIndex or uncollectedSourceIndex or 1;
end

function AnvilWardrobeCollectionFrame_SetAppearanceTooltip(contentFrame, sources, primarySourceID)
	AnvilWardrobeCollectionFrame.tooltipContentFrame = contentFrame;

	for i = 1, #sources do
		if ( sources[i].isHideVisual ) then
			GameTooltip:SetText(sources[i].name);
			return;
		end
	end

	local firstVisualID = sources[1].visualID;
	local passedFirstVisualID = false;

	local headerIndex;
	if ( not AnvilWardrobeCollectionFrame.tooltipSourceIndex ) then
		headerIndex = AnvilWardrobeCollectionFrame_GetDefaultSourceIndex(sources, primarySourceID);
	else
		headerIndex = AnvilWardrobeUtils_GetValidIndexForNumSources(AnvilWardrobeCollectionFrame.tooltipSourceIndex, #sources);
	end
	AnvilWardrobeCollectionFrame.tooltipSourceIndex = headerIndex;
	headerSourceID = sources[headerIndex].sourceID;

	local name, nameColor, sourceText, sourceColor = AnvilWardrobeCollectionFrameModel_GetSourceTooltipInfo(sources[headerIndex]);
	GameTooltip:SetText(name, nameColor.r, nameColor.g, nameColor.b);

	if ( sources[headerIndex].sourceType == TRANSMOG_SOURCE_BOSS_DROP and not sources[headerIndex].isCollected ) then
		local drops = C_TransmogCollection.GetAppearanceSourceDrops(headerSourceID);
		if ( drops and #drops > 0 ) then
			local showDifficulty = false;
			if ( #drops == 1 ) then
				sourceText = _G["TRANSMOG_SOURCE_"..TRANSMOG_SOURCE_BOSS_DROP]..": "..string.format(WARDROBE_TOOLTIP_ENCOUNTER_SOURCE, drops[1].encounter, drops[1].instance);
				showDifficulty = true;
			else
				local sameInstance = true;
				local firstInstance = drops[1].instance;
				for i = 2, #drops do
					if ( drops[i].instance ~= firstInstance ) then
						sameInstance = false;
						break;
					end
				end
				local sameTier = true;
				local firstTier = drops[1].tiers[1];
				if ( not sameInstance and #drops[1].tiers == 1 ) then
					for i = 2, #drops do
						if ( #drops[i].tiers > 1 or drops[i].tiers[1] ~= firstTier ) then
							sameTier = false;
							break;
						end
					end
				end
				local sameDifficulty = false;
				local sameInstanceType = false;
				if ( sameInstance or sameTier ) then
					sameDifficulty = true;
					sameInstanceType = true;
					for i = 2, #drops do
						if ( drops[1].instanceType ~= drops[i].instanceType ) then
							sameInstanceType = false;
						end
						if ( #drops[1].difficulties ~= #drops[i].difficulties ) then
							sameDifficulty = false;
						else
							for j = 1, #drops[1].difficulties do
								if ( drops[1].difficulties[j] ~= drops[i].difficulties[j] ) then
									sameDifficulty = false;
									break;
								end
							end
						end
					end
				end
				if ( sameInstance ) then
					sourceText = _G["TRANSMOG_SOURCE_"..TRANSMOG_SOURCE_BOSS_DROP]..": "..firstInstance;
					showDifficulty = sameDifficulty;
				elseif ( sameTier ) then
					local location = firstTier;
					if ( sameInstanceType ) then
						if ( drops[1].instanceType == INSTANCE_TYPE_DUNGEON ) then
							location = string.format(WARDROBE_TOOLTIP_DUNGEONS, location);
						elseif ( drops[1].instanceType == INSTANCE_TYPE_RAID ) then
							location = string.format(WARDROBE_TOOLTIP_RAIDS, location);
						end
					end
					sourceText = _G["TRANSMOG_SOURCE_"..TRANSMOG_SOURCE_BOSS_DROP]..": "..location;
				end
			end
			if ( showDifficulty ) then
				local diffText = GetDropDifficulties(drops[1]);
				if ( diffText ) then
					sourceText = sourceText.." "..string.format(PARENS_TEMPLATE, diffText);
				end
			end
		end
	end
	if ( not sources[headerIndex].isCollected ) then
		GameTooltip:AddLine(sourceText, sourceColor.r, sourceColor.g, sourceColor.b, 1, 1);
	end

	local useError;
	local appearanceCollected = sources[headerIndex].isCollected
	if ( #sources > 1 and not appearanceCollected ) then
		if ( firstVisualID == sources[2].visualID ) then
			GameTooltip:AddLine(" ");
			GameTooltip:AddLine(WARDROBE_OTHER_ITEMS, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
		end
		for i = 1, #sources do
			if ( not passedFirstVisualID and firstVisualID ~= sources[i].visualID ) then
				passedFirstVisualID = true;
				GameTooltip:AddLine(" ");
				GameTooltip:AddLine(WARDROBE_ALTERNATE_ITEMS);
			end

			local name, nameColor, sourceText, sourceColor = AnvilWardrobeCollectionFrameModel_GetSourceTooltipInfo(sources[i]);
			if ( i == headerIndex ) then
				name = WARDROBE_TOOLTIP_CYCLE_ARROW_ICON..name;
				useError = sources[i].useError;
			else
				name = WARDROBE_TOOLTIP_CYCLE_SPACER_ICON..name;
			end
			GameTooltip:AddDoubleLine(name, sourceText, nameColor.r, nameColor.g, nameColor.b, sourceColor.r, sourceColor.g, sourceColor.b);
		end	
		GameTooltip:AddLine(" ");
		GameTooltip:AddLine(WARDROBE_TOOLTIP_CYCLE, GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b, true);
		AnvilWardrobeCollectionFrame.tooltipCycle = true;
	else
		useError = sources[headerIndex].useError;
		AnvilWardrobeCollectionFrame.tooltipCycle = nil;
	end

	if ( appearanceCollected  ) then
		if ( useError ) then
			GameTooltip:AddLine(useError, RED_FONT_COLOR.r, RED_FONT_COLOR.g, RED_FONT_COLOR.b, true);
		else
			GameTooltip:AddLine(WARDROBE_TOOLTIP_TRANSMOGRIFIER, GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b, 1, 1);
		end
	end

	GameTooltip:Show();
end

function AnvilWardrobeCollectionFrameModel_GetSourceTooltipInfo(source)
	local name, nameColor;
	if ( source.name ) then
		name = source.name;
		nameColor = ITEM_QUALITY_COLORS[source.quality];
	else
		name = RETRIEVING_ITEM_INFO;
		nameColor = RED_FONT_COLOR;
		sourceText = "";
	end

	local sourceText, sourceColor;
	if ( source.isCollected ) then
		sourceText = TRANSMOG_COLLECTED;
		sourceColor = GREEN_FONT_COLOR;
	else
		if ( source.sourceType ) then
			sourceText = _G["TRANSMOG_SOURCE_"..source.sourceType];
		end
		sourceColor = HIGHLIGHT_FONT_COLOR;
	end

	return name, nameColor, sourceText, sourceColor;
end

function AnvilWardrobeItemsCollectionMixin:GetChosenVisualSource(visualID)
	return self.chosenVisualSources[visualID] or NO_TRANSMOG_SOURCE_ID;
end

function AnvilWardrobeItemsCollectionMixin:SetChosenVisualSource(visualID, sourceID)
	self.chosenVisualSources[visualID] = sourceID;
end

function AnvilWardrobeItemsCollectionMixin:ValidateChosenVisualSources()
	for visualID, sourceID in pairs(self.chosenVisualSources) do
		if ( sourceID ~= NO_TRANSMOG_SOURCE_ID ) then
			local keep = false;
			local sources = C_TransmogCollection.GetAppearanceSources(visualID);
			if ( sources ) then
				for i = 1, #sources do
					if ( sources[i].sourceID == sourceID ) then
						if ( sources[i].isCollected and not sources[i].useError ) then
							keep = true;
						end
						break;
					end
				end
			end
			if ( not keep ) then
				self.chosenVisualSources[visualID] = NO_TRANSMOG_SOURCE_ID;
			end
		end
	end
end

function AnvilWardrobeCollectionFrameRightClickDropDown_Init(self)
	local appearanceID = self.activeFrame.visualInfo.visualID;
	local info = UIDropDownMenu_CreateInfo();
	if ( C_TransmogCollection.GetIsAppearanceFavorite(appearanceID) ) then
		info.text = BATTLE_PET_UNFAVORITE;
		info.arg1 = appearanceID;
		info.arg2 = 0;
	else
		info.text = BATTLE_PET_FAVORITE;
		info.arg1 = appearanceID;
		info.arg2 = 1;
		if ( not C_TransmogCollection.CanSetFavoriteInCategory(AnvilWardrobeCollectionFrame.ItemsCollectionFrame:GetActiveCategory()) ) then
			info.tooltipWhileDisabled = 1
			info.tooltipTitle = BATTLE_PET_FAVORITE;
			info.tooltipText = TRANSMOG_CATEGORY_FAVORITE_LIMIT;
			info.tooltipOnButton = 1;
			info.disabled = 1;
		end
	end
	info.notCheckable = true;
	info.func = function(_, visualID, value) AnvilWardrobeCollectionFrameModelDropDown_SetFavorite(visualID, value); end;
	UIDropDownMenu_AddButton(info);
	info = UIDropDownMenu_CreateInfo();
	info.notCheckable = true;
	info.text = CANCEL;
	UIDropDownMenu_AddButton(info);
end

function AnvilWardrobeCollectionFrameModelDropDown_SetSource(self, visualID, sourceID)
	AnvilWardrobeCollectionFrame.ItemsCollectionFrame:SetChosenVisualSource(visualID, sourceID);
end

function AnvilWardrobeCollectionFrameModelDropDown_SetFavorite(visualID, value, confirmed)
	local set = (value == 1);
	if ( set and not confirmed ) then
		local allSourcesConditional = true;
		local sources = C_TransmogCollection.GetAppearanceSources(visualID);
		for i, sourceInfo in ipairs(sources) do
			local info = C_TransmogCollection.GetAppearanceInfoBySource(sourceInfo.sourceID);
			if ( info.sourceIsCollectedPermanent ) then
				allSourcesConditional = false;
				break;
			end
		end
		if ( allSourcesConditional ) then
			StaticPopup_Show("TRANSMOG_FAVORITE_WARNING", nil, nil, visualID);
			return;
		end
	end
	C_TransmogCollection.SetIsAppearanceFavorite(visualID, set);
	SetCVarBitfield("closedInfoFrames", LE_FRAME_TUTORIAL_TRANSMOG_MODEL_CLICK, true);
	AnvilWardrobeCollectionFrame.ItemsCollectionFrame.HelpBox:Hide();
end

function AnvilWardrobeCollectionFrameWeaponDropDown_OnLoad(self)
	UIDropDownMenu_Initialize(self, AnvilWardrobeCollectionFrameWeaponDropDown_Init);
	UIDropDownMenu_SetWidth(self, 140);
end

function AnvilWardrobeCollectionFrameWeaponDropDown_Init(self)
	local slot = AnvilWardrobeCollectionFrame.ItemsCollectionFrame:GetActiveSlot();
	if ( not slot ) then
		return;
	end

	local selectedValue = UIDropDownMenu_GetSelectedValue(self);
	local info = UIDropDownMenu_CreateInfo();
	info.func = AnvilWardrobeCollectionFrameWeaponDropDown_OnClick;

	local equippedItemID = GetInventoryItemID("player", GetInventorySlotInfo(slot));
	local checkCategory = equippedItemID
	if ( checkCategory ) then
		local isTransmogrified, hasPending, isPendingCollected, canTransmogrify, cannotTransmogrifyReason, hasUndo = C_Transmog.GetSlotInfo(GetInventorySlotInfo(slot), LE_TRANSMOG_TYPE_APPEARANCE);
		if ( not canTransmogrify and not hasUndo ) then
			checkCategory = false;
		end
	end
	local buttonsAdded = 0;
	
	for categoryID = FIRST_TRANSMOG_COLLECTION_WEAPON_TYPE, LAST_TRANSMOG_COLLECTION_WEAPON_TYPE do
		local name, isWeapon, canEnchant, canMainHand, canOffHand = C_TransmogCollection.GetCategoryInfo(categoryID);
		if ( name and isWeapon ) then
			if ( (slot == "MAINHANDSLOT" and canMainHand) or (slot == "SECONDARYHANDSLOT" and canOffHand) ) then
				if ( not checkCategory or C_TransmogCollection.IsCategoryValidForItem(categoryID, equippedItemID) ) then
					info.text = name;
					info.arg1 = categoryID;
					info.value = categoryID;
					if ( info.value == selectedValue ) then
						info.checked = 1;
					else
						info.checked = nil;
					end
					UIDropDownMenu_AddButton(info);
					buttonsAdded = buttonsAdded + 1;
				end
			end
		end
	end
	return buttonsAdded;
end

function AnvilWardrobeCollectionFrameWeaponDropDown_OnClick(self, category)
	if ( category and AnvilWardrobeCollectionFrame.ItemsCollectionFrame:GetActiveCategory() ~= category ) then
		CloseDropDownMenus();
		AnvilWardrobeCollectionFrame.ItemsCollectionFrame:SetActiveCategory(category);
	end	
end

function AnvilWardrobeItemsCollectionMixin:OnPageChanged(userAction)
	PlaySound(SOUNDKIT.UI_TRANSMOG_PAGE_TURN);
	CloseDropDownMenus();
	if ( userAction ) then
		self:UpdateItems();
	end
end

function AnvilWardrobeCollectionFrame_SwitchSearchCategory()
	if ( AnvilWardrobeCollectionFrame.ItemsCollectionFrame.transmogType == LE_TRANSMOG_TYPE_ILLUSION ) then
		AnvilWardrobeCollectionFrame_ClearSearch();
		AnvilWardrobeCollectionFrame.searchBox:Disable();
		AnvilWardrobeCollectionFrame.FilterButton:Disable();
		return;
	end

	AnvilWardrobeCollectionFrame.searchBox:Enable();
	AnvilWardrobeCollectionFrame.FilterButton:Enable();
	if ( AnvilWardrobeCollectionFrame.searchBox:GetText() ~= "" )  then
		local finished = C_TransmogCollection.SetSearch(AnvilWardrobeCollectionFrame.activeFrame.searchType, AnvilWardrobeCollectionFrame.searchBox:GetText());
		if ( not finished ) then
			AnvilWardrobeCollectionFrame_RestartSearchTracking();
		end
	end
end

function AnvilWardrobeItemsCollectionMixin:OnSearchUpdate(category)
	if ( category ~= self.activeCategory ) then
		return;
	end

	self:RefreshVisualsList();
	if ( self.resetPageOnSearchUpdated ) then
		self.resetPageOnSearchUpdated = nil;
		self:ResetPage();
	else
		self:UpdateItems();
	end
end

function AnvilWardrobeCollectionFrame_RestartSearchTracking()
	if ( AnvilWardrobeCollectionFrame.activeFrame.transmogType == LE_TRANSMOG_TYPE_ILLUSION ) then
		return;
	end

	local searchSize = C_TransmogCollection.SearchSize(AnvilWardrobeCollectionFrame.activeFrame.searchType);
	local searchProgress = C_TransmogCollection.SearchProgress(AnvilWardrobeCollectionFrame.activeFrame.searchType);

	AnvilWardrobeCollectionFrame.searchProgressFrame:Hide();
	AnvilWardrobeCollectionFrame.searchBox.updateDelay = 0;
	if ( not C_TransmogCollection.IsSearchInProgress(AnvilWardrobeCollectionFrame.activeFrame.searchType) ) then
		AnvilWardrobeCollectionFrame.activeFrame:OnSearchUpdate();
	else
		AnvilWardrobeCollectionFrame.searchBox:SetScript("OnUpdate", AnvilWardrobeCollectionFrameSearchBox_OnUpdate);
	end
end

function AnvilWardrobeCollectionFrame_ClearSearch(searchType)
	AnvilWardrobeCollectionFrame.searchBox:SetText("");
	AnvilWardrobeCollectionFrame.searchProgressFrame:Hide();
	C_TransmogCollection.ClearSearch(searchType or AnvilWardrobeCollectionFrame.activeFrame.searchType);
end

function AnvilWardrobeCollectionFrameSearchProgressBar_OnLoad(self)
	self:SetStatusBarColor(0, .6, 0, 1);
	self:SetMinMaxValues(0, 1000);
	self:SetValue(0);
	self:GetStatusBarTexture():SetDrawLayer("BORDER");
end

function AnvilWardrobeCollectionFrameSearchProgressBar_OnHide(self)
	self:SetValue(0);
	self:SetScript("OnUpdate", nil);
end

function AnvilWardrobeCollectionFrameSearchProgressBar_OnUpdate(self, elapsed)
	local _, maxValue = self:GetMinMaxValues();
	local searchSize = C_TransmogCollection.SearchSize(AnvilWardrobeCollectionFrame.activeFrame.searchType);
	local searchProgress = C_TransmogCollection.SearchProgress(AnvilWardrobeCollectionFrame.activeFrame.searchType);
	self:SetValue((searchProgress * maxValue) / searchSize);
	
	if ( not C_TransmogCollection.IsSearchInProgress(AnvilWardrobeCollectionFrame.activeFrame.searchType) ) then
		AnvilWardrobeCollectionFrame.searchProgressFrame:Hide();
	end
end

function AnvilWardrobeCollectionFrameSearchBox_OnLoad(self)
	SearchBoxTemplate_OnLoad(self);
	self:SetScript("OnUpdate", nil);
	self.updateDelay = 0;
end

function AnvilWardrobeCollectionFrameSearchBox_OnHide(self)
	self:SetScript("OnUpdate", nil);
	self.updateDelay = 0;
	AnvilWardrobeCollectionFrame.searchProgressFrame:Hide();
end

function AnvilWardrobeCollectionFrameSearchBox_OnKeyDown(self, key, ...)
	if ( key == WARDROBE_CYCLE_KEY ) then
		AnvilWardrobeCollectionFrame_OnKeyDown(AnvilWardrobeCollectionFrame, key, ...);
	end
end

local WARDROBE_SEARCH_DELAY = 0.6;

function AnvilWardrobeCollectionFrameSearchBox_OnUpdate(self, elapsed)
	self.updateDelay = self.updateDelay + elapsed;
	
	if ( not C_TransmogCollection.IsSearchInProgress(AnvilWardrobeCollectionFrame.activeFrame.searchType) ) then
		self:SetScript("OnUpdate", nil);
		self.updateDelay = 0;
	elseif ( self.updateDelay >= WARDROBE_SEARCH_DELAY ) then
		self:SetScript("OnUpdate", nil);
		self.updateDelay = 0;
		
		if ( not C_TransmogCollection.IsSearchDBLoading() ) then
			AnvilWardrobeCollectionFrame.searchProgressFrame.loading:Hide();
			AnvilWardrobeCollectionFrame.searchProgressFrame.searchProgressBar:Show();
			AnvilWardrobeCollectionFrame.searchProgressFrame.searchProgressBar:SetScript("OnUpdate", AnvilWardrobeCollectionFrameSearchProgressBar_OnUpdate);
		else
			AnvilWardrobeCollectionFrame.searchProgressFrame.loading:Show();
			AnvilWardrobeCollectionFrame.searchProgressFrame.searchProgressBar:Hide();
		end
		
		AnvilWardrobeCollectionFrame.searchProgressFrame:Show();
	end
end

function AnvilWardrobeCollectionFrameSearchBox_OnTextChanged(self)
	SearchBoxTemplate_OnTextChanged(self);
	
	local text = self:GetText();
	if ( text == "" ) then
		C_TransmogCollection.ClearSearch(AnvilWardrobeCollectionFrame.activeFrame.searchType);
	else
		C_TransmogCollection.SetSearch(AnvilWardrobeCollectionFrame.activeFrame.searchType, text);
	end
	
	AnvilWardrobeCollectionFrame_RestartSearchTracking();
end

function AnvilWardrobeFilterDropDown_OnLoad(self)
	UIDropDownMenu_Initialize(self, AnvilWardrobeFilterDropDown_Initialize, "MENU");
end

function AnvilWardrobeFilterDropDown_Initialize(self, level)
	if ( not AnvilWardrobeCollectionFrame.activeFrame ) then
		return;
	end

	if ( AnvilWardrobeCollectionFrame.activeFrame.searchType == LE_TRANSMOG_SEARCH_TYPE_ITEMS ) then
		AnvilWardrobeFilterDropDown_InitializeItems(self, level);
	elseif ( AnvilWardrobeCollectionFrame.activeFrame.searchType == LE_TRANSMOG_SEARCH_TYPE_BASE_SETS ) then
		AnvilWardrobeFilterDropDown_InitializeBaseSets(self, level);
	end
end

function AnvilWardrobeFilterDropDown_InitializeItems(self, level)
	local info = UIDropDownMenu_CreateInfo();
	info.keepShownOnClick = true;

	if level == 1 then
		info.text = COLLECTED
		info.func = function(_, _, _, value)
						C_TransmogCollection.SetCollectedShown(value);
					end 
		info.checked = C_TransmogCollection.GetCollectedShown();
		info.isNotRadio = true;
		UIDropDownMenu_AddButton(info, level)

		info.text = NOT_COLLECTED
		info.func = function(_, _, _, value)
						C_TransmogCollection.SetUncollectedShown(value);
					end 
		info.checked = C_TransmogCollection.GetUncollectedShown();
		info.isNotRadio = true;
		UIDropDownMenu_AddButton(info, level)

		info.checked = 	nil;
		info.isNotRadio = nil;
		info.func =  nil;
		info.hasArrow = true;
		info.notCheckable = true;

		info.text = SOURCES
		info.value = 1;
		UIDropDownMenu_AddButton(info, level)
	else
		if level == 2 then
			local refreshLevel = 2;
			info.hasArrow = false;
			info.isNotRadio = true;
			info.notCheckable = true;

			info.text = CHECK_ALL
			info.func = function()
							C_TransmogCollection.SetAllSourceTypeFilters(true);
							UIDropDownMenu_Refresh(AnvilWardrobeFilterDropDown, 1, refreshLevel);
						end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = UNCHECK_ALL
			info.func = function()
							C_TransmogCollection.SetAllSourceTypeFilters(false);
							UIDropDownMenu_Refresh(AnvilWardrobeFilterDropDown, 1, refreshLevel);
						end
			UIDropDownMenu_AddButton(info, level)
			info.notCheckable = false;

			local numSources = C_TransmogCollection.GetNumTransmogSources();
			for i = 1, numSources do
				info.text = _G["TRANSMOG_SOURCE_"..i];
				info.func = function(_, _, _, value)
							C_TransmogCollection.SetSourceTypeFilter(i, value);
						end
				info.checked = function() return not C_TransmogCollection.IsSourceTypeFilterChecked(i) end;
				UIDropDownMenu_AddButton(info, level);
			end
		end
	end
end

function AnvilWardrobeFilterDropDown_InitializeBaseSets(self, level)
	local info = UIDropDownMenu_CreateInfo();
	info.keepShownOnClick = true;
	info.isNotRadio = true;

	info.text = COLLECTED;
	info.func = function(_, _, _, value)
					C_TransmogSets.SetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_COLLECTED, value);
				end 
	info.checked = C_TransmogSets.GetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_COLLECTED);
	UIDropDownMenu_AddButton(info, level);

	info.text = NOT_COLLECTED;
	info.func = function(_, _, _, value)
					C_TransmogSets.SetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_UNCOLLECTED, value);
				end 
	info.checked = C_TransmogSets.GetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_UNCOLLECTED);
	UIDropDownMenu_AddButton(info, level);

	UIDropDownMenu_AddSeparator(info);
	info = UIDropDownMenu_CreateInfo();
	info.keepShownOnClick = true;
	info.isNotRadio = true;
	
	info.text = TRANSMOG_SET_PVE;
	info.func = function(_, _, _, value)
					C_TransmogSets.SetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_PVE, value);
				end 
	info.checked = C_TransmogSets.GetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_PVE);
	UIDropDownMenu_AddButton(info, level);

	info.text = TRANSMOG_SET_PVP;
	info.func = function(_, _, _, value)
					C_TransmogSets.SetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_PVP, value);
				end 
	info.checked = C_TransmogSets.GetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_PVP);
	UIDropDownMenu_AddButton(info, level);
end

local BASE_SET_BUTTON_HEIGHT = 46;
local VARIANT_SET_BUTTON_HEIGHT = 20;
local SET_PROGRESS_BAR_MAX_WIDTH = 204;
local IN_PROGRESS_FONT_COLOR = CreateColor(0.251, 0.753, 0.251);
local IN_PROGRESS_FONT_COLOR_CODE = "|cff40c040";

AnvilWardrobeSetsDataProviderMixin = {};

function AnvilWardrobeSetsDataProviderMixin:SortSets(sets, reverseUIOrder)
	local comparison = function(set1, set2)
		local groupFavorite1 = set1.favoriteSetID and true;
		local groupFavorite2 = set2.favoriteSetID and true;
		if ( groupFavorite1 ~= groupFavorite2 ) then
			return groupFavorite1;
		end
		if ( set1.favorite ~= set2.favorite ) then
			return set1.favorite;
		end
		if ( set1.uiOrder ~= set2.uiOrder ) then
			if ( reverseUIOrder ) then
				return set1.uiOrder < set2.uiOrder;
			else
				return set1.uiOrder > set2.uiOrder;
			end
		end
		return set1.setID > set2.setID;
	end

	table.sort(sets, comparison);
end

function AnvilWardrobeSetsDataProviderMixin:GetBaseSets()
	if ( not self.baseSets ) then
		self.baseSets = C_TransmogSets.GetBaseSets();
		self:DetermineFavorites();
		self:SortSets(self.baseSets);
	end
	return self.baseSets;
end

function AnvilWardrobeSetsDataProviderMixin:GetBaseSetByID(baseSetID)
	local baseSets = self:GetBaseSets();
	for i = 1, #baseSets do
		if ( baseSets[i].setID == baseSetID ) then
			return baseSets[i], i;
		end
	end
	return nil, nil;
end

function AnvilWardrobeSetsDataProviderMixin:GetUsableSets()
	if ( not self.usableSets ) then
		self.usableSets = C_TransmogSets.GetUsableSets();
		self:SortSets(self.usableSets);
		for i, set in ipairs(self.usableSets) do
			if ( not set.favorite ) then
				local baseSetID = set.baseSetID or set.setID;
				local numRelatedSets = 0;
				for j = i + 1, #self.usableSets do
					if ( self.usableSets[j].baseSetID == baseSetID or self.usableSets[j].setID == baseSetID ) then
						numRelatedSets = numRelatedSets + 1;
						if ( j ~= i + numRelatedSets ) then
							local relatedSet = self.usableSets[j];
							tremove(self.usableSets, j);
							tinsert(self.usableSets, i + numRelatedSets, relatedSet);
						end
					end
				end
			end
		end
	end
	return self.usableSets;
end

function AnvilWardrobeSetsDataProviderMixin:GetVariantSets(baseSetID)
	if ( not self.variantSets ) then
		self.variantSets = { };
	end

	local variantSets = self.variantSets[baseSetID];
	if ( not variantSets ) then
		variantSets = C_TransmogSets.GetVariantSets(baseSetID);
		self.variantSets[baseSetID] = variantSets;
		if ( #variantSets > 0 ) then
			local baseSet = self:GetBaseSetByID(baseSetID);
			if ( baseSet ) then
				tinsert(variantSets, baseSet);
			end
			self:SortSets(variantSets, true);
		end
	end
	return variantSets;
end

function AnvilWardrobeSetsDataProviderMixin:GetSetSourceData(setID)
	if ( not self.sourceData ) then
		self.sourceData = { };
	end

	local sourceData = self.sourceData[setID];
	if ( not sourceData ) then
		local sources = C_TransmogSets.GetSetSources(setID);
		local numCollected = 0;
		local numTotal = 0;
		for sourceID, collected in pairs(sources) do
			if ( collected ) then
				numCollected = numCollected + 1;
			end
			numTotal = numTotal + 1;
		end
		sourceData = { numCollected = numCollected, numTotal = numTotal, sources = sources };
		self.sourceData[setID] = sourceData;
	end
	return sourceData;
end

function AnvilWardrobeSetsDataProviderMixin:GetSetSources(setID)
	return self:GetSetSourceData(setID).sources;
end

function AnvilWardrobeSetsDataProviderMixin:GetSetSourceCounts(setID)
	local sourceData = self:GetSetSourceData(setID);
	return sourceData.numCollected, sourceData.numTotal;
end

function AnvilWardrobeSetsDataProviderMixin:GetBaseSetData(setID)
	if ( not self.baseSetsData ) then
		self.baseSetsData = { };
	end
	if ( not self.baseSetsData[setID] ) then
		local baseSetID = C_TransmogSets.GetBaseSetID(setID);
		if ( baseSetID ~= setID ) then
			return;
		end
		local topCollected, topTotal = self:GetSetSourceCounts(setID);
		local variantSets = self:GetVariantSets(setID);
		for i = 1, #variantSets do
			local numCollected, numTotal = self:GetSetSourceCounts(variantSets[i].setID);
			if ( numCollected > topCollected ) then
				topCollected = numCollected;
				topTotal = numTotal;
			end
		end
		local setInfo = { topCollected = topCollected, topTotal = topTotal, completed = (topCollected == topTotal) };
		self.baseSetsData[setID] = setInfo;
	end
	return self.baseSetsData[setID];
end

function AnvilWardrobeSetsDataProviderMixin:GetSetSourceTopCounts(setID)
	local baseSetData = self:GetBaseSetData(setID);
	if ( baseSetData ) then
		return baseSetData.topCollected, baseSetData.topTotal;
	else
		return self:GetSetSourceCounts(setID);
	end
end

function AnvilWardrobeSetsDataProviderMixin:IsBaseSetNew(baseSetID)
	local baseSetData = self:GetBaseSetData(baseSetID)
	if ( not baseSetData.newStatus ) then
		local newStatus = C_TransmogSets.SetHasNewSources(baseSetID);
		if ( not newStatus ) then
			local variantSets = self:GetVariantSets(baseSetID);
			for i, variantSet in ipairs(variantSets) do
				if ( C_TransmogSets.SetHasNewSources(variantSet.setID) ) then
					newStatus = true;
					break;
				end
			end
		end
		baseSetData.newStatus = newStatus;
	end
	return baseSetData.newStatus;
end

function AnvilWardrobeSetsDataProviderMixin:ResetBaseSetNewStatus(baseSetID)
	local baseSetData = self:GetBaseSetData(baseSetID)
	if ( baseSetData ) then
		baseSetData.newStatus = nil;
	end
end

function AnvilWardrobeSetsDataProviderMixin:GetSortedSetSources(setID)
	local returnTable = { };
	local sourceData = self:GetSetSourceData(setID);
	for sourceID, collected in pairs(sourceData.sources) do
		local sourceInfo = C_TransmogCollection.GetSourceInfo(sourceID);
		if ( sourceInfo ) then
			local sortOrder = EJ_GetInvTypeSortOrder(sourceInfo.invType);
			tinsert(returnTable, { sourceID = sourceID, collected = collected, sortOrder = sortOrder, itemID = sourceInfo.itemID, invType = sourceInfo.invType });
		end
	end

	local comparison = function(entry1, entry2)
		if ( entry1.sortOrder == entry2.sortOrder ) then
			return entry1.itemID < entry2.itemID;
		else
			return entry1.sortOrder < entry2.sortOrder;
		end
	end
	table.sort(returnTable, comparison);
	return returnTable;
end

function AnvilWardrobeSetsDataProviderMixin:ClearSets()
	self.baseSets = nil;
	self.baseSetsData = nil;
	self.variantSets = nil;
	self.usableSets = nil;
	self.sourceData = nil;
end

function AnvilWardrobeSetsDataProviderMixin:ClearBaseSets()
	self.baseSets = nil;
end

function AnvilWardrobeSetsDataProviderMixin:ClearVariantSets()
	self.variantSets = nil;
end

function AnvilWardrobeSetsDataProviderMixin:ClearUsableSets()
	self.usableSets = nil;
end

function AnvilWardrobeSetsDataProviderMixin:GetIconForSet(setID)
	local sourceData = self:GetSetSourceData(setID);
	if ( not sourceData.icon ) then
		local sortedSources = self:GetSortedSetSources(setID);
		if ( sortedSources[1] ) then
			local _, _, _, _, icon = GetItemInfoInstant(sortedSources[1].itemID);
			sourceData.icon = icon;
		else
			sourceData.icon = QUESTION_MARK_ICON;
		end
	end
	return sourceData.icon;
end

function AnvilWardrobeSetsDataProviderMixin:DetermineFavorites()
	local baseSets = self:GetBaseSets();
	for i = 1, #baseSets do
		local baseSet = baseSets[i];
		baseSet.favoriteSetID = nil;
		if ( baseSet.favorite ) then
			baseSet.favoriteSetID = baseSet.setID;
		else
			local variantSets = self:GetVariantSets(baseSet.setID);
			for j = 1, #variantSets do
				if ( variantSets[j].favorite ) then
					baseSet.favoriteSetID = variantSets[j].setID;
					break;
				end
			end
		end
	end
end

function AnvilWardrobeSetsDataProviderMixin:RefreshFavorites()
	self.baseSets = nil;
	self.variantSets = nil;
	self:DetermineFavorites();
end

local SetsDataProvider = CreateFromMixins(AnvilWardrobeSetsDataProviderMixin);

AnvilWardrobeSetsCollectionMixin = {};

function AnvilWardrobeSetsCollectionMixin:OnLoad()
	AnvilWardrobeCollectionDressUpFrame.DetailsFrame.itemFramesPool = CreateFramePool("FRAME", AnvilWardrobeCollectionDressUpFrame.DetailsFrame, "AnvilWardrobeDetailsItemFrameTemplate");

	self.selectedVariantSets = { };
end

function AnvilWardrobeSetsCollectionMixin:OnShow()
	self:RegisterEvent("GET_ITEM_INFO_RECEIVED");
	self:RegisterEvent("TRANSMOG_COLLECTION_UPDATED");
	local baseSets = SetsDataProvider:GetBaseSets();
	if ( not self.init ) then
		self.init = true;
		if ( baseSets and baseSets[1] ) then
			self:SelectSet(self:GetDefaultSetIDForBaseSet(baseSets[1].setID));
		end
	else
		self:Refresh();
	end

	local latestSource = C_TransmogSets.GetLatestSource();

	if ( latestSource ~= NO_TRANSMOG_SOURCE_ID ) then
		local sets = C_TransmogSets.GetSetsContainingSourceID(latestSource);
		local setID = sets and sets[1];
		if ( setID ) then
			self:SelectSet(setID);
			local baseSetID = C_TransmogSets.GetBaseSetID(setID);
			self:ScrollToSet(baseSetID);
		end
		self:ClearLatestSource();
	end

	AnvilWardrobeCollectionFrame_UpdateProgressBar(C_TransmogSets.GetBaseSetsCounts());
	self:RefreshCameras();

	if (self:GetParent().SetsTabHelpBox:IsShown()) then
		self:GetParent().SetsTabHelpBox:Hide()
		SetCVarBitfield("closedInfoFrames", LE_FRAME_TUTORIAL_TRANSMOG_SETS_TAB, true);
	end
end

function AnvilWardrobeSetsCollectionMixin:OnHide()
	self:UnregisterEvent("GET_ITEM_INFO_RECEIVED");
	self:UnregisterEvent("TRANSMOG_COLLECTION_UPDATED");
	SetsDataProvider:ClearSets();
	AnvilWardrobeCollectionFrame_ClearSearch(LE_TRANSMOG_SEARCH_TYPE_BASE_SETS);
end

function AnvilWardrobeSetsCollectionMixin:OnEvent(event, ...)
	if ( event == "GET_ITEM_INFO_RECEIVED" ) then
		local itemID = ...;
		for itemFrame in AnvilWardrobeCollectionDressUpFrame.DetailsFrame.itemFramesPool:EnumerateActive() do
			if ( itemFrame.itemID == itemID ) then
				self:SetItemFrameQuality(itemFrame);
				break;
			end
		end
	elseif ( event == "TRANSMOG_COLLECTION_UPDATED" ) then
		SetsDataProvider:ClearSets();
		self:Refresh();
		AnvilWardrobeCollectionFrame_UpdateProgressBar(C_TransmogSets.GetBaseSetsCounts());
		self:ClearLatestSource();
	end
end

function AnvilWardrobeSetsCollectionMixin:ClearLatestSource()
	C_TransmogSets.ClearLatestSource();
	AnvilWardrobeCollectionFrame_UpdateTabButtons();
end

function AnvilWardrobeSetsCollectionMixin:Refresh()
	self.ScrollFrame:Update();
	self:DisplaySet(self:GetSelectedSetID());
end

function AnvilWardrobeSetsCollectionMixin:DisplaySet(setID)
	local setInfo = (setID and C_TransmogSets.GetSetInfo(setID)) or nil;
	if ( not setInfo ) then
		AnvilWardrobeCollectionDressUpFrame.DetailsFrame:Hide();
		AnvilWardrobeCollectionDressUpFrame.DressUpModel:Hide();
		return;
	else
		AnvilWardrobeCollectionDressUpFrame.DetailsFrame:Show();
		AnvilWardrobeCollectionDressUpFrame.DressUpModel:Show();
	end

	AnvilWardrobeCollectionDressUpFrame.DetailsFrame.Name:SetText(setInfo.name);
	if ( AnvilWardrobeCollectionDressUpFrame.DetailsFrame.Name:IsTruncated() ) then
		AnvilWardrobeCollectionDressUpFrame.DetailsFrame.Name:Hide();
		AnvilWardrobeCollectionDressUpFrame.DetailsFrame.LongName:SetText(setInfo.name);
		AnvilWardrobeCollectionDressUpFrame.DetailsFrame.LongName:Show();
	else
		AnvilWardrobeCollectionDressUpFrame.DetailsFrame.Name:Show();
		AnvilWardrobeCollectionDressUpFrame.DetailsFrame.LongName:Hide();
	end
	AnvilWardrobeCollectionDressUpFrame.DetailsFrame.Label:SetText(setInfo.label);
	local newSourceIDs = C_TransmogSets.GetSetNewSources(setID);
	AnvilWardrobeCollectionDressUpFrame.DetailsFrame.itemFramesPool:ReleaseAll();
	AnvilWardrobeCollectionDressUpFrame.DressUpModel:Undress();
	local BUTTON_SPACE = 37;
	local sortedSources = SetsDataProvider:GetSortedSetSources(setID);
	local xOffset = -floor((#sortedSources - 1) * BUTTON_SPACE / 2);
	for i = 1, #sortedSources do
		local itemFrame = AnvilWardrobeCollectionDressUpFrame.DetailsFrame.itemFramesPool:Acquire();
		itemFrame.sourceID = sortedSources[i].sourceID;
		itemFrame.itemID = sortedSources[i].itemID;
		itemFrame.collected = sortedSources[i].collected;
		itemFrame.invType = sortedSources[i].invType;
		local texture = C_TransmogCollection.GetSourceIcon(sortedSources[i].sourceID);
		itemFrame.Icon:SetTexture(texture);
		if ( sortedSources[i].collected ) then
			itemFrame.Icon:SetDesaturated(false);
			itemFrame.Icon:SetAlpha(1);
			itemFrame.IconBorder:SetDesaturation(0);
			itemFrame.IconBorder:SetAlpha(1);

			local transmogSlot = C_Transmog.GetSlotForInventoryType(itemFrame.invType);

			if ( C_TransmogSets.SetHasNewSourcesForSlot(setID, transmogSlot) ) then
				itemFrame.New:Show();
				itemFrame.New.Anim:Play();
			else
				itemFrame.New:Hide();
				itemFrame.New.Anim:Stop();
			end
		else
			itemFrame.Icon:SetDesaturated(true);
			itemFrame.Icon:SetAlpha(0.3);
			itemFrame.IconBorder:SetDesaturation(1);
			itemFrame.IconBorder:SetAlpha(0.3);
			itemFrame.New:Hide();
		end
		self:SetItemFrameQuality(itemFrame);
		itemFrame:SetPoint("TOP", AnvilWardrobeCollectionDressUpFrame.DetailsFrame, "TOP", xOffset + (i - 1) * BUTTON_SPACE, -94);
		itemFrame:Show();
		AnvilWardrobeCollectionDressUpFrame.DressUpModel:TryOn(sortedSources[i].sourceID);
	end

	local baseSetID = C_TransmogSets.GetBaseSetID(setID);
	local variantSets = SetsDataProvider:GetVariantSets(baseSetID);
	if ( #variantSets == 0 )  then
		AnvilWardrobeCollectionDressUpFrame.DetailsFrame.VariantSetsButton:Hide();
	else
		AnvilWardrobeCollectionDressUpFrame.DetailsFrame.VariantSetsButton:Show();
		AnvilWardrobeCollectionDressUpFrame.DetailsFrame.VariantSetsButton:SetText(setInfo.description);
	end
end

function AnvilWardrobeSetsCollectionMixin:SetItemFrameQuality(itemFrame)
	if ( itemFrame.collected ) then
		local quality = C_TransmogCollection.GetSourceInfo(itemFrame.sourceID).quality;
		if ( quality == LE_ITEM_QUALITY_UNCOMMON ) then
			itemFrame.IconBorder:SetAtlas("loottab-set-itemborder-green", true);
		elseif ( quality == LE_ITEM_QUALITY_RARE ) then
			itemFrame.IconBorder:SetAtlas("loottab-set-itemborder-blue", true);
		elseif ( quality == LE_ITEM_QUALITY_EPIC ) then
			itemFrame.IconBorder:SetAtlas("loottab-set-itemborder-purple", true);
		end
	end
end

function AnvilWardrobeSetsCollectionMixin:OnSearchUpdate()
	if ( self.init ) then
		SetsDataProvider:ClearBaseSets();
		SetsDataProvider:ClearVariantSets();
		SetsDataProvider:ClearUsableSets();
		self:Refresh();
	end
end

function AnvilWardrobeSetsCollectionMixin:OnUnitModelChangedEvent()
	if ( AnvilWardrobeCollectionDressUpFrame.DressUpModel:CanSetUnit("player") ) then
		AnvilWardrobeCollectionDressUpFrame.DressUpModel:RefreshUnit();
		AnvilWardrobeCollectionDressUpFrame.DressUpModel.cameraID = nil;
		self:RefreshCameras();
		self:Refresh();
		return true;
	else
		return false;
	end
end

function AnvilWardrobeSetsCollectionMixin:RefreshCameras()
	if ( self:IsShown() ) then
		local detailsCameraID, transmogCameraID = C_TransmogSets.GetCameraIDs();
		local model = AnvilWardrobeCollectionDressUpFrame.DressUpModel;
		model:RefreshCamera();
		Model_ApplyUICamera(model, detailsCameraID);
		if ( model.cameraID ~= detailsCameraID ) then
			model.cameraID = detailsCameraID;
			model.defaultPosX, model.defaultPosY, model.defaultPosZ, model.yaw = GetUICameraInfo(detailsCameraID);
		end
		if AnvilWardrobeCollectionDressUpFrame.DressUpModel.playOrPause == "play" then
			AnvilWardrobeCollectionDressUpFrame.DressUpModel:SetAnimation(2)
		elseif AnvilWardrobeCollectionDressUpFrame.DressUpModel.playOrPause == "pause" then
			AnvilWardrobeCollectionDressUpFrame.DressUpModel:SetAnimation(3)
		end
	end
end

function AnvilWardrobeSetsCollectionMixin:OpenVariantSetsDropDown()
	local selectedSetID = self:GetSelectedSetID();
	if ( not selectedSetID ) then
		return;
	end
	local info = UIDropDownMenu_CreateInfo();
	local baseSetID = C_TransmogSets.GetBaseSetID(selectedSetID);
	local variantSets = SetsDataProvider:GetVariantSets(baseSetID);
	for i = 1, #variantSets do
		local variantSet = variantSets[i];
		local numSourcesCollected, numSourcesTotal = SetsDataProvider:GetSetSourceCounts(variantSet.setID);
		local colorCode = IN_PROGRESS_FONT_COLOR_CODE;
		if ( numSourcesCollected == numSourcesTotal ) then
			colorCode = NORMAL_FONT_COLOR_CODE;
		elseif ( numSourcesCollected == 0 ) then
			colorCode = GRAY_FONT_COLOR_CODE;
		end
		info.text = format(ITEM_SET_NAME, variantSet.description..colorCode, numSourcesCollected, numSourcesTotal);
		info.checked = (variantSet.setID == selectedSetID);
		info.func = function() self:SelectSet(variantSet.setID); end;
		UIDropDownMenu_AddButton(info);
	end
end

function AnvilWardrobeSetsCollectionMixin:GetDefaultSetIDForBaseSet(baseSetID)
	if ( SetsDataProvider:IsBaseSetNew(baseSetID) ) then
		if ( C_TransmogSets.SetHasNewSources(baseSetID) ) then
			return baseSetID;
		else
			local variantSets = SetsDataProvider:GetVariantSets(baseSetID);
			for i, variantSet in ipairs(variantSets) do
				if ( C_TransmogSets.SetHasNewSources(variantSet.setID) ) then
					return variantSet.setID;
				end
			end
		end
	end

	if ( self.selectedVariantSets[baseSetID] ) then
		return self.selectedVariantSets[baseSetID];
	end

	local baseSet = SetsDataProvider:GetBaseSetByID(baseSetID);
	if ( baseSet.favoriteSetID ) then
		return baseSet.favoriteSetID;
	end
	local highestCount = 0;
	local highestCountSetID;
	local variantSets = SetsDataProvider:GetVariantSets(baseSetID);	
	for i = 1, #variantSets do
		local variantSetID = variantSets[i].setID;
		local numCollected = SetsDataProvider:GetSetSourceCounts(variantSetID);
		if ( numCollected > 0 and numCollected >= highestCount ) then
			highestCount = numCollected;
			highestCountSetID = variantSetID;
		end
	end
	return highestCountSetID or baseSetID;
end

function AnvilWardrobeSetsCollectionMixin:SelectSetFromButton(setID)
	CloseDropDownMenus();
	self:SelectSet(self:GetDefaultSetIDForBaseSet(setID));
end

function AnvilWardrobeSetsCollectionMixin:SelectSet(setID)
	self.selectedSetID = setID;

	local baseSetID = C_TransmogSets.GetBaseSetID(setID);
	local variantSets = SetsDataProvider:GetVariantSets(baseSetID);
	if ( #variantSets > 0 ) then
		self.selectedVariantSets[baseSetID] = setID;
	end

	self:Refresh();
end

function AnvilWardrobeSetsCollectionMixin:GetSelectedSetID()
	return self.selectedSetID;
end

function AnvilWardrobeSetsCollectionMixin:SetAppearanceTooltip(frame)
	GameTooltip:SetOwner(frame, "ANCHOR_RIGHT");
	self.tooltipTransmogSlot = C_Transmog.GetSlotForInventoryType(frame.invType);
	self.tooltipPrimarySourceID = frame.sourceID;
	self:RefreshAppearanceTooltip();
end

function AnvilWardrobeSetsCollectionMixin:RefreshAppearanceTooltip()
	if ( not self.tooltipTransmogSlot ) then
		return;
	end

	local sources = C_TransmogSets.GetSourcesForSlot(self:GetSelectedSetID(), self.tooltipTransmogSlot);
	if ( #sources == 0 ) then
		local sourceInfo = C_TransmogCollection.GetSourceInfo(self.tooltipPrimarySourceID);
		tinsert(sources, sourceInfo);
	end
	AnvilWardrobeCollectionFrame_SortSources(sources, sources[1].visualID, self.tooltipPrimarySourceID);
	AnvilWardrobeCollectionFrame_SetAppearanceTooltip(self, sources, self.tooltipPrimarySourceID);
end

function AnvilWardrobeSetsCollectionMixin:ClearAppearanceTooltip()
	self.tooltipTransmogSlot = nil;
	self.tooltipPrimarySourceID = nil;
	AnvilWardrobeCollectionFrame_HideAppearanceTooltip();
end

function AnvilWardrobeSetsCollectionMixin:CanHandleKey(key)
	if ( key == WARDROBE_UP_VISUAL_KEY or key == WARDROBE_DOWN_VISUAL_KEY ) then
		return true;
	end
	return false;
end

function AnvilWardrobeSetsCollectionMixin:HandleKey(key)
	if ( not self:GetSelectedSetID() ) then
		return false;
	end
	local selectedSetID = C_TransmogSets.GetBaseSetID(self:GetSelectedSetID());
	local _, index = SetsDataProvider:GetBaseSetByID(selectedSetID);
	if ( not index ) then
		return;
	end
	if ( key == WARDROBE_DOWN_VISUAL_KEY ) then
		index = index + 1;
	elseif ( key == WARDROBE_UP_VISUAL_KEY ) then
		index = index - 1;
	end
	local sets = SetsDataProvider:GetBaseSets();
	index = Clamp(index, 1, #sets);
	self:SelectSet(self:GetDefaultSetIDForBaseSet(sets[index].setID));
	self:ScrollToSet(sets[index].setID);
end

function AnvilWardrobeSetsCollectionMixin:ScrollToSet(setID)
	local totalHeight = 0;
	local scrollFrameHeight = self.ScrollFrame:GetHeight();
	local buttonHeight = self.ScrollFrame.buttonHeight;
	for i, set in ipairs(SetsDataProvider:GetBaseSets()) do
		if ( set.setID == setID ) then
			local offset = self.ScrollFrame.scrollBar:GetValue();
			if ( totalHeight + buttonHeight > offset + scrollFrameHeight ) then
				offset = totalHeight + buttonHeight - scrollFrameHeight;
			elseif ( totalHeight < offset ) then
				offset = totalHeight;
			end
			self.ScrollFrame.scrollBar:SetValue(offset, true);
			break;
		end
		totalHeight = totalHeight + buttonHeight;
	end
end

do
	local function OpenVariantSetsDropDown(self)
		if AnvilWardrobeCollectionFrame.SetsCollectionFrame then
			AnvilWardrobeCollectionFrame.SetsCollectionFrame:OpenVariantSetsDropDown();
		end
	end

	function AnvilWardrobeSetsCollectionVariantSetsDropDown_OnLoad(self)
		UIDropDownMenu_Initialize(self, OpenVariantSetsDropDown, "MENU");
	end
end

AnvilWardrobeSetsCollectionScrollFrameMixin = { };

local function AnvilWardrobeSetsCollectionScrollFrame_FavoriteDropDownInit(self)
	if ( not self.baseSetID ) then
		return;
	end

	local baseSet = SetsDataProvider:GetBaseSetByID(self.baseSetID);
	local variantSets = SetsDataProvider:GetVariantSets(self.baseSetID);
	local useDescription = (#variantSets > 0);

	local info = UIDropDownMenu_CreateInfo();
	info.notCheckable = true;
	info.disabled = nil;

	if ( baseSet.favoriteSetID ) then
		if ( useDescription ) then
			local setInfo = C_TransmogSets.GetSetInfo(baseSet.favoriteSetID);
			info.text = format(TRANSMOG_SETS_UNFAVORITE_WITH_DESCRIPTION, setInfo.description);
		else
			info.text = BATTLE_PET_UNFAVORITE;
		end
		info.func = function()
			C_TransmogSets.SetIsFavorite(baseSet.favoriteSetID, false);
		end
	else
		local targetSetID = AnvilWardrobeCollectionFrame.SetsCollectionFrame:GetDefaultSetIDForBaseSet(self.baseSetID);
		if ( useDescription ) then
			local setInfo = C_TransmogSets.GetSetInfo(targetSetID);
			info.text = format(TRANSMOG_SETS_FAVORITE_WITH_DESCRIPTION, setInfo.description);
		else
			info.text = BATTLE_PET_FAVORITE;
		end
		info.func = function()
			C_TransmogSets.SetIsFavorite(targetSetID, true);
		end
	end

	UIDropDownMenu_AddButton(info, level);
	info.disabled = nil;

	info.text = CANCEL;
	info.func = nil;
	UIDropDownMenu_AddButton(info, level);
end

function AnvilWardrobeSetsCollectionScrollFrameMixin:OnLoad()
	self.scrollBar.trackBG:Show();
	self.scrollBar.trackBG:SetVertexColor(0, 0, 0, 0.75);
	self.scrollBar.doNotHide = true;
	self.update = self.Update;
	HybridScrollFrame_CreateButtons(self, "AnvilWardrobeSetsScrollFrameButtonTemplate", 44, 0);
	UIDropDownMenu_Initialize(self.FavoriteDropDown, AnvilWardrobeSetsCollectionScrollFrame_FavoriteDropDownInit, "MENU");
end

function AnvilWardrobeSetsCollectionScrollFrameMixin:OnShow()
	self:RegisterEvent("TRANSMOG_SETS_UPDATE_FAVORITE");
	self:ResizeSetsScrollFrame()
end

function AnvilWardrobeSetsCollectionScrollFrameMixin:ResizeSetsScrollFrame()
	AnvilWardrobeCollectionFrameScrollFrame.stepSize = Anvil.db.global.collectionsWidth*46
	wipe(self.buttons)
	for i=1, 55 do
		if i<=11*Anvil.db.global.collectionsWidth then
			if not _G["AnvilWardrobeCollectionFrameScrollFrameButton"..i] then
				_G["AnvilWardrobeCollectionFrameScrollFrameButton"..i] = CreateFrame("Button", "$parentButton"..i, AnvilWardrobeCollectionFrameScrollFrameScrollChild, "AnvilWardrobeSetsScrollFrameButtonTemplate")
			end
			tinsert(self.buttons, _G["AnvilWardrobeCollectionFrameScrollFrameButton"..i])
		elseif _G["AnvilWardrobeCollectionFrameScrollFrameButton"..i] then
			_G["AnvilWardrobeCollectionFrameScrollFrameButton"..i]:Hide()
		end
	end
	self:Update()
	for i=1, 11 do
		for j=1, Anvil.db.global.collectionsWidth do
			_G["AnvilWardrobeCollectionFrameScrollFrameButton"..(i-1)*Anvil.db.global.collectionsWidth+j]:SetPoint("TOPLEFT", AnvilWardrobeCollectionFrameScrollFrame, "TOPLEFT", 48+(j-1)*256, -46*(i-1))
		end
	end
end

function AnvilWardrobeSetsCollectionScrollFrameMixin:OnHide()
	self:UnregisterEvent("TRANSMOG_SETS_UPDATE_FAVORITE");
end

function AnvilWardrobeSetsCollectionScrollFrameMixin:OnEvent(event, ...)
	if ( event == "TRANSMOG_SETS_UPDATE_FAVORITE" ) then
		SetsDataProvider:RefreshFavorites();
		self:Update();
	end
end

function AnvilWardrobeSetsCollectionScrollFrameMixin:Update()
	local offset = HybridScrollFrame_GetOffset(self);
	local buttons = self.buttons;
	local baseSets = SetsDataProvider:GetBaseSets();

	local selectedSetID = self:GetParent():GetSelectedSetID();
	local selectedBaseSetID = selectedSetID and C_TransmogSets.GetBaseSetID(selectedSetID);

	for i = 1, #buttons do
		local button = buttons[i];
		local setIndex = i + offset;
		if ( setIndex <= #baseSets ) then
			local baseSet = baseSets[setIndex];
			button:Show();
			button.Name:SetText(baseSet.name);
			local topSourcesCollected, topSourcesTotal = SetsDataProvider:GetSetSourceTopCounts(baseSet.setID);
			local setCollected = C_TransmogSets.IsBaseSetCollected(baseSet.setID);
			local color = IN_PROGRESS_FONT_COLOR;
			if ( setCollected ) then
				color = NORMAL_FONT_COLOR;
			elseif ( topSourcesCollected == 0 ) then
				color = GRAY_FONT_COLOR;
			end
			button.Name:SetTextColor(color.r, color.g, color.b);
			button.Label:SetText(baseSet.label);
			button.Icon:SetTexture(SetsDataProvider:GetIconForSet(baseSet.setID));
			button.Icon:SetDesaturation((topSourcesCollected == 0) and 1 or 0);
			button.SelectedTexture:SetShown(baseSet.setID == selectedBaseSetID);
			button.Favorite:SetShown(baseSet.favoriteSetID);
			button.New:SetShown(SetsDataProvider:IsBaseSetNew(baseSet.setID));
			button.setID = baseSet.setID;

			if ( topSourcesCollected == 0 or setCollected ) then
				button.ProgressBar:Hide();
			else
				button.ProgressBar:Show();
				button.ProgressBar:SetWidth(SET_PROGRESS_BAR_MAX_WIDTH * topSourcesCollected / topSourcesTotal);
			end
			button.IconCover:SetShown(not setCollected);
		else
			button:Hide();
		end
	end
	
	local totalHeight = 46*(Anvil.db.global.collectionsWidth*ceil(#baseSets/Anvil.db.global.collectionsWidth)-11*(Anvil.db.global.collectionsWidth-1))+4
	HybridScrollFrame_Update(self, totalHeight, self:GetHeight());
end

AnvilWardrobeDetailsItemMixin = { };

function AnvilWardrobeDetailsItemMixin:OnEnter()
	AnvilWardrobeCollectionFrame.SetsCollectionFrame:SetAppearanceTooltip(self)

	if ( self.New:IsShown() ) then
		local transmogSlot = C_Transmog.GetSlotForInventoryType(self.invType);
		local setID = AnvilWardrobeCollectionFrame.SetsCollectionFrame:GetSelectedSetID();
		C_TransmogSets.ClearSetNewSourcesForSlot(setID, transmogSlot);
		local baseSetID = C_TransmogSets.GetBaseSetID(setID);
		SetsDataProvider:ResetBaseSetNewStatus(baseSetID);
		AnvilWardrobeCollectionFrame.SetsCollectionFrame:Refresh();
	end
end

function AnvilWardrobeDetailsItemMixin:OnLeave()
	self:SetScript("OnUpdate", nil);
	ResetCursor();
	AnvilWardrobeCollectionFrame_HideAppearanceTooltip();
end

function AnvilWardrobeDetailsItemMixin:OnMouseDown(button)
	if button == "RightButton" then
		AnvilWardrobeCollectionDressUpFrame.DressUpModel:UndressSlot(self.slotID)
		self.displayedItem = nil
		self.itemID = nil
		AnvilDrawDressUpButtons()
		GameTooltip:Hide()
	elseif ( IsModifiedClick("CHATLINK") ) then
		local sourceInfo = C_TransmogCollection.GetSourceInfo(self.sourceID);
		local slot = C_Transmog.GetSlotForInventoryType(sourceInfo.invType);
		local sources = C_TransmogSets.GetSourcesForSlot(self:GetParent():GetParent():GetSelectedSetID(), slot);
		if ( #sources == 0 ) then
			tinsert(sources, sourceInfo);
		end
		AnvilWardrobeCollectionFrame_SortSources(sources, sourceInfo.visualID, self.sourceID);
		if ( AnvilWardrobeCollectionFrame.tooltipSourceIndex ) then
			local index = AnvilWardrobeUtils_GetValidIndexForNumSources(AnvilWardrobeCollectionFrame.tooltipSourceIndex, #sources);
			local link = select(6, C_TransmogCollection.GetAppearanceSourceInfo(sources[index].sourceID));
			if ( link ) then
				HandleModifiedItemClick(link);
			end
		end
	end
end
