AnvilArchaeology = Anvil:NewModule("AnvilArchaeology", "AceConsole-3.0", "AceEvent-3.0")
local _G = _G

function AnvilArchaeology:OnEnable()
	if not Anvil.db.global.archaeology then
		return
	else
		if not IsAddOnLoaded("Blizzard_ArchaeologyUI") then
			LoadAddOn("Blizzard_ArchaeologyUI")
		end
		ArchaeologyFrameInfoButton:Hide()
		ArchaeologyFrameRaceFilter:SetScript("OnHide", function()
			ArchaeologyFrame.rankBar:ClearAllPoints();
			ArchaeologyFrame.rankBar:SetPoint("TOP", 0, -60);
		end)
		ArchaeologyFrameSummaryPageRace1:SetPoint("TOPLEFT", ArchaeologyFrameInsetBg, "TOPLEFT", 8, -30)
		ArchaeologyFrameFactionIcon:ClearAllPoints()
		ArchaeologyFrameFactionIcon:SetPoint("TOPLEFT", ArchaeologyFrameInsetBg, "TOPLEFT", 5, -5)
-- Might have to change if Blizzard ever notices their typo
		ArchaeologyFrameSummarytButton:SetPoint("TOPLEFT", ArchaeologyFrame, "TOPRIGHT", -10, -50)
		ArchaeologyFrameCompletedButton:SetPoint("TOPLEFT", ArchaeologyFrame, "TOPRIGHT", -10, -120)
		ArchaeologyFrameInsetBg:SetPoint("TOPLEFT", 16, -60)
		ArchaeologyFrameInsetBg:SetPoint("BOTTOMRIGHT", -16, 16)
		ArchaeologyFrameSummaryPageTitle:SetPoint("TOP", ArchaeologyFrame, "TOP", 0, -95)
		ArchaeologyFrameSummaryPageTitle:SetTextColor(1,1,1)
		ArchaeologyFrameRankBar:SetPoint("TOP", 0, -60)
		ArchaeologyFrameArtifactPageHistoryTitle:SetTextColor(1,1,1)
		ArchaeologyFrameArtifactPageHistoryScrollChildText:SetTextColor(1,1,1)
		for i=1, GetNumArchaeologyRaces() do
			if not ArchaeologyFrameSummaryPage["race"..i] then
				ArchaeologyFrameSummaryPage["race"..i] = CreateFrame("Button", "$parentRace"..i, ArchaeologyFrameSummaryPage, "ArchaeologyRaceTemplate")
				ArchaeologyFrameSummaryPage["race"..i]:SetID(i)
			end
			ArchaeologyFrameSummaryPage["race"..i]:Show()
			ArchaeologyFrameSummaryPage["race"..i].raceName:SetTextColor(1,1,1)
			if i==6 or i==11 or i==16 then
				ArchaeologyFrameSummaryPage["race"..i]:SetPoint("TOPLEFT", ArchaeologyFrameSummaryPage["race"..i-5], "BOTTOMLEFT", 0, -20)
			elseif i~=1 then
				ArchaeologyFrameSummaryPage["race"..i]:SetPoint("TOPLEFT", ArchaeologyFrameSummaryPage["race"..i-1], "TOPRIGHT", 20, 0)
			end
		end
		ARCHAEOLOGY_MAX_RACES = GetNumArchaeologyRaces()
		ARCHAEOLOGY_MAX_COMPLETED_SHOWN = 14
		ArchaeologyFrame:SetSize(560,600)
		ArchaeologyFrameBgLeft:Hide()
		ArchaeologyFrameSummaryPagePageText:Hide()
		ArchaeologyFrameSummaryPagePrevPageButton:Hide()
		ArchaeologyFrameSummaryPageNextPageButton:Hide()
		ArchaeologyFrameArtifactPageIconBG:Hide()
		ArchaeologyFrameCompletedPagePageText:SetTextColor(1,1,1)
		ArchaeologyFrameCompletedPageTitleTop:SetTextColor(1,1,1)
		ArchaeologyFrameCompletedPageTitleMid:SetTextColor(1,1,1)
		ArchaeologyFrameCompletedPageArtifact1:SetPoint("TOPLEFT", ArchaeologyFrameInsetBg, "TOPLEFT", 16, -35)
		for i=1, ARCHAEOLOGY_MAX_COMPLETED_SHOWN do
			if not ArchaeologyFrameCompletedPage["artifact"..i] then
				ArchaeologyFrameCompletedPage["artifact"..i] = CreateFrame("Button", "$parentArtifact"..i, ArchaeologyFrameCompletedPage, "ArchaeologyArtifactTemplate")
			end
			ArchaeologyFrameCompletedPage["artifact"..i]:Show()
			_G["ArchaeologyFrameCompletedPageArtifact"..i.."ArtifactName"]:SetTextColor(1,1,1)
			_G["ArchaeologyFrameCompletedPageArtifact"..i.."ArtifactSubText"]:SetTextColor(1,1,1)
			ArchaeologyFrameCompletedPage["artifact"..i]:SetWidth(240)
			_G["ArchaeologyFrameCompletedPageArtifact"..i.."ArtifactName"]:SetWidth(170)
			_G["ArchaeologyFrameCompletedPageArtifact"..i.."ArtifactSubText"]:SetWidth(170)
			if i>12 then
				if i/2 ~= 1 then
					ArchaeologyFrameCompletedPage["artifact"..i]:SetPoint("TOPLEFT", ArchaeologyFrameCompletedPage["artifact"..i-2], "BOTTOMLEFT", 0, -15)
				else
					ArchaeologyFrameCompletedPage["artifact"..i]:SetPoint("TOPLEFT", ArchaeologyFrameCompletedPage["artifact"..i-1], "BOTTOMLEFT", 20, 0)
				end
			end
		end
		ArchaeologyFrameHelpPageTitle:SetTextColor(1,1,1)
		ArchaeologyFrameHelpPageTitle:SetPoint("TOP", ArchaeologyFrame, "TOP", 0, -95)
		ArchaeologyFrameHelpPageHelpScrollHelpText:SetTextColor(1,1,1)
		ArchaeologyFrameHelpPageHelpScrollHelpText:SetPoint("TOP", ArchaeologyFrameInsetBg, "TOP", 0, -30)
		ArchaeologyFrameHelpPageDigTitle:SetTextColor(1,1,1)
		ArchaeologyFrameHelpPageDigTex:SetPoint("TOP", ArchaeologyFrameHelpPageHelpScrollHelpText, "BOTTOM", 0, -20)
		ArchaeologyFrameHelpPageDigTex:SetPoint("BOTTOM", ArchaeologyFrameInsetBg, "BOTTOM", 0, 8)
		ArchaeologyFrameHelpPageDigTex:SetPoint("LEFT", ArchaeologyFrameInsetBg, "LEFT", 8, 0)
		ArchaeologyFrameHelpPageDigTex:SetPoint("RIGHT", ArchaeologyFrameInsetBg, "RIGHT", -8, 0)
		hooksecurefunc("ArchaeologyFrame_OnTabClick", AnvilArchaeology_OnTabClick)
		ArchaeologyFrameArtifactPageFinishedGlow:SetAllPoints()
		ArchaeologyFrameArtifactPage:SetPoint("TOPLEFT", 0, -45)
		ArchaeologyFrameArtifactPageRaceBG:ClearAllPoints()
		ArchaeologyFrameArtifactPageRaceBG:SetPoint("TOPLEFT", 25, -100)
		ArchaeologyFrameArtifactPageRaceBG:SetSize(ArchaeologyFrame:GetWidth()/2, 300)
		ArchaeologyFrame.artifactPage.backButton:ClearAllPoints()
		ArchaeologyFrame.artifactPage.backButton:SetPoint("BOTTOMLEFT", ArchaeologyFrameInsetBg, 4, 4)
	end
end

function AnvilArchaeology:OnDisable()
	ArchaeologyFrameInfoButton:Show()
	ArchaeologyFrameRaceFilter:SetScript("OnHide", function()
		ArchaeologyFrame.rankBar:ClearAllPoints();
		ArchaeologyFrame.rankBar:SetPoint("TOP", 20, -60);
	end)
	ArchaeologyFrameSummaryPageRace1:SetPoint("TOPLEFT", ArchaeologyFrameSummaryPage, "TOPLEFT", 60, -85)
	ArchaeologyFrameFactionIcon:ClearAllPoints()
	ArchaeologyFrameFactionIcon:SetPoint("LEFT", ArchaeologyFrame, "LEFT", 41, -10)
-- Might have to change if Blizzard ever notices their typo
	ArchaeologyFrameSummarytButton:SetPoint("TOPLEFT", ArchaeologyFrame, "TOPRIGHT", -22, -50)
	ArchaeologyFrameCompletedButton:SetPoint("TOPLEFT", ArchaeologyFrame, "TOPRIGHT", -22, -120)
	ArchaeologyFrameInsetBg:SetAllPoints()
	ArchaeologyFrameSummaryPageTitle:SetPoint("TOP", ArchaeologyFrameSummaryPage, "TOP", 0, -55)
	ArchaeologyFrameSummaryPageTitle:SetTextColor(.23,.15,0)
	ArchaeologyFrameRankBar:SetPoint("TOP", 20, -60)
	ArchaeologyFrameArtifactPageHistoryTitle:SetTextColor(.23,.15,0)
	ArchaeologyFrameArtifactPageHistoryScrollChildText:SetTextColor(.25,.13,0)
	for i=1, GetNumArchaeologyRaces() do
		if i>12 and ArchaeologyFrameSummaryPage["race"..i] then
			ArchaeologyFrameSummaryPage["race"..i]:Hide()
		end
		if _G["ArchaeologyFrameSummaryPageRace"..i] then
			ArchaeologyFrameSummaryPage["race"..i].raceName:SetTextColor(.25,.13,0)
		end
		if i==5 or i==9 then
			ArchaeologyFrameSummaryPage["race"..i]:SetPoint("TOPLEFT", ArchaeologyFrameSummaryPage["race"..i-4], "BOTTOMLEFT", 0, -30)
		elseif i~=1 and i<13 then
			ArchaeologyFrameSummaryPage["race"..i]:SetPoint("TOPLEFT", ArchaeologyFrameSummaryPage["race"..i-1], "TOPRIGHT", 13, 0)
		end
	end
	ARCHAEOLOGY_MAX_RACES = 12
	ARCHAEOLOGY_MAX_COMPLETED_SHOWN = 12
	ArchaeologyFrame:SetSize(550,525)
	ArchaeologyFrameBgLeft:Show()
	ArchaeologyFrameSummaryPagePageText:Show()
	ArchaeologyFrameSummaryPagePrevPageButton:Show()
	ArchaeologyFrameSummaryPageNextPageButton:Show()
	ArchaeologyFrameArtifactPageIconBG:Show()
	ArchaeologyFrameCompletedPagePageText:SetTextColor(.25,.13,0)
	ArchaeologyFrameCompletedPageTitleTop:SetTextColor(.25,.13,0)
	ArchaeologyFrameCompletedPageTitleMid:SetTextColor(.25,.13,0)
	ArchaeologyFrameCompletedPageArtifact1:SetPoint("TOPLEFT", ArchaeologyFrameCompletedPage, "TOPLEFT", 35, -90)
	for i=1, 14 do
		if ArchaeologyFrameCompletedPage["artifact"..i] and i>12 then
			ArchaeologyFrameCompletedPage["artifact"..i]:Hide()
		end
		_G["ArchaeologyFrameCompletedPageArtifact"..i.."ArtifactName"]:SetTextColor(.25,.13,0)
		_G["ArchaeologyFrameCompletedPageArtifact"..i.."ArtifactSubText"]:SetTextColor(.25,.13,0)
		ArchaeologyFrameCompletedPage["artifact"..i]:SetWidth(200)
		_G["ArchaeologyFrameCompletedPageArtifact"..i.."ArtifactName"]:SetWidth(130)
		_G["ArchaeologyFrameCompletedPageArtifact"..i.."ArtifactSubText"]:SetWidth(130)
	end
	ArchaeologyFrameHelpPageTitle:SetTextColor(.25,.13,0)
	ArchaeologyFrameHelpPageTitle:SetPoint("TOP", ArchaeologyFrameHelpPage, "TOP", 0, -35)
	ArchaeologyFrameHelpPageHelpScrollHelpText:SetTextColor(.25,.13,0)
	ArchaeologyFrameHelpPageHelpScrollHelpText:SetPoint("TOP", ArchaeologyFrameHelpPageHelpScroll, "TOP", 0, -4)
	ArchaeologyFrameHelpPageDigTitle:SetTextColor(.25,.13,0)
	ArchaeologyFrameHelpPageDigTex:ClearAllPoints()
	ArchaeologyFrameHelpPageDigTex:SetSize(480,243)
	ArchaeologyFrameHelpPageDigTex:SetPoint("BOTTOM", ArchaeologyFrameHelpPage, "BOTTOM", 0, 30)
	ArchaeologyFrameArtifactPageFinishedGlow:SetPoint("CENTER", 9, 6)
	ArchaeologyFrameArtifactPage:SetPoint("TOPLEFT", "$parentInset", "TOPLEFT", 45, -15)
	ArchaeologyFrameArtifactPageRaceBG:ClearAllPoints()
	ArchaeologyFrameArtifactPageRaceBG:SetPoint("LEFT", 25, 50)
	ArchaeologyFrameArtifactPageRaceBG:SetSize(256, 300)
	ArchaeologyFrame.artifactPage.backButton:ClearAllPoints()
	ArchaeologyFrame.artifactPage.backButton:SetPoint("BOTTOMLEFT", 30, 40)
end

function AnvilArchaeology_OnTabClick(self)
	if Anvil.db.global.archaeology then
		if self:GetID()==1 then
			ArchaeologyFrameInsetBg:SetPoint("BOTTOMLEFT", 16, 16)
			ArchaeologyFrameInsetBg:SetPoint("BOTTOMRIGHT", -16, 16)
		else
			ArchaeologyFrameInsetBg:SetPoint("BOTTOMLEFT", 16, 50)
			ArchaeologyFrameInsetBg:SetPoint("BOTTOMRIGHT", -16, 50)
		end
	end
end
