AnvilVendor = Anvil:NewModule("AnvilVendor", "AceConsole-3.0", "AceEvent-3.0")
local _G = _G
local MAX_MONEY_DISPLAY_WIDTH = 120

function AnvilVendor:OnInitialize()
	hooksecurefunc("MerchantFrame_UpdateMerchantInfo", AnvilVendor_UpdateMerchantInfo)
	hooksecurefunc("MerchantFrame_UpdateBuybackInfo", AnvilVendor_UpdateBuybackInfo)
	self:ResizeVendorFrame()
end

function AnvilVendor:ResizeVendorFrame()
	MerchantFrame:SetSize((Anvil.db.global.vendorWidth * 162) + 24, (Anvil.db.global.vendorHeight * 54) + 176)
	MERCHANT_ITEMS_PER_PAGE = Anvil.db.global.vendorWidth * Anvil.db.global.vendorHeight
	MerchantNextPageButton:SetPoint("RIGHT", "MerchantFrame", "RIGHT", -15, 0)
	MerchantFrame:SetScale(Anvil.db.global.vendorScale)
	for i=13, MERCHANT_ITEMS_PER_PAGE do
		if not _G["MerchantItem"..i] then
			_G["MerchantItem"..i] = CreateFrame("Frame", "MerchantItem"..i, MerchantFrame, "MerchantItemTemplate")
		end
	end
	if MerchantFrame:IsVisible() then
		MerchantFrame_Update()
		MerchantFrame.page = 1
	end
end

function AnvilVendor_UpdateMerchantInfo()
	Anvil:MakeMovable("vendorIsMovable", "MerchantFrame")
	local numMerchantItems = GetMerchantNumItems();
	for i = MERCHANT_ITEMS_PER_PAGE+1, 100 do
		if _G["MerchantItem"..i] then
			_G["MerchantItem"..i]:Hide()
		end
	end
	AnvilVendor_ArrangeButtons()
	for i=1, MERCHANT_ITEMS_PER_PAGE do
		if (i>(numMerchantItems-(MERCHANT_ITEMS_PER_PAGE*(MerchantFrame.page-1))) and Anvil.db.global.vendorHideExtra) then
			_G["MerchantItem"..i]:Hide()
		else
			_G["MerchantItem"..i]:Show()
		end
	end
	MerchantBuyBackItem:ClearAllPoints()
	MerchantBuyBackItem:SetPoint("BOTTOMLEFT", MerchantFrame, "BOTTOMLEFT", 175, 33)
end

function AnvilVendor_ArrangeButtons()
	for i=1, Anvil.db.global.vendorHeight do
		for j=1, Anvil.db.global.vendorWidth do
			_G["MerchantItem"..(i-1)*(Anvil.db.global.vendorWidth)+j]:SetPoint("TOPLEFT", MerchantFrame, "TOPLEFT", (j-1)*162+12, -i*54-16)
		end
	end
end

function AnvilVendor_UpdateBuybackInfo()
	local numBuybackItems = GetNumBuybackItems()
	for i = 1, 12 do
		AnvilVendor_ArrangeButtons()
		if i>numBuybackItems and Anvil.db.global.vendorHideExtra then
			_G["MerchantItem"..i]:Hide()
		else
			_G["MerchantItem"..i]:Show()
		end
	end
	for i=13, MERCHANT_ITEMS_PER_PAGE do
		_G["MerchantItem"..i]:Hide()
	end
end
